//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by Measurement Studio.
//     Runtime Version:2.0.50727.832
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace NationalInstruments.ModularInstruments.Interop
{
    using System;
    using System.Runtime.InteropServices;


    public class nidmm : object, System.IDisposable
    {

        private System.IntPtr _handle;

        private bool _disposed = true;

        ~nidmm() { Dispose(false); }


        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_init
        /// 
        /// ViStatus = niDMM_init(ViString Resource_Name, ViBoolean ID_Query, ViBoolean Reset_Device, ViSession* Instrument_Handle)
        /// 
        /// Purpose
        /// 
        /// This function completes the following tasks:
        /// Creates a new IVI instrument driver session.
        /// Opens a session to the device you specify for the Resource_Name parameter. 
        /// If the ID_Query parameter is set to VI_TRUE (1), this function queries the instrument ID and checks that it is valid for this instrument driver.
        /// If the Reset_Device parameter is set to VI_TRUE (1), this function resets the instrument to a known state. Sends initialization commands to set the instrument to the state necessary for the operation of the instrument driver.
        /// Returns a ViSession handle that you use to identify the instrument in all subsequent instrument driver function calls.
        /// 
        /// </summary>
        /// <param name="Resource_Name">
        /// 
        /// 
        /// 
        /// 
        /// Resource_Name
        /// ViString
        /// Contains the Resource_Name of the device to initialize. The Resource_Name is assigned in Measurement &amp; Automation Explorer (MAX). 
        /// 
        /// Refer to  Related Documentation for the NI&#160;Digital Multimeters Getting Started Guide for more information about configuring and testing the DMM in MAX.
        /// 
        /// Valid Syntax:
        /// 
        /// 
        /// 
        /// NI-DAQmx name
        /// DAQ::NI-DAQmx name[::INSTR]
        /// DAQ::Traditional NI-DAQ device number[::INSTR]
        /// IVI logical name
        /// 
        /// 
        /// Caution&#160;&#160;All IVI names for the Resource_Name, such as logical names or virtual names, are case-sensitive. If you use logical names, driver session names, or virtual names in your program, you must make sure that the name you use matches the name in the IVI Configuration Store file exactly, without any variations in the case of the characters in the name.
        /// 
        /// </param>
        /// <param name="ID__Query">
        /// 
        /// 
        /// 
        /// 
        /// ID_Query
        /// ViBoolean
        /// Verifies that the 
        /// device you initialize is one that the driver supports. NI-DMM 
        /// automatically performs this query, so setting this parameter is not necessary.
        /// 
        /// Defined Values:
        /// 
        /// 
        /// 
        /// VI_TRUE (default)
        /// 1
        /// Perform ID Query
        /// VI_FALSE
        /// 0
        /// Skip ID Query
        /// 
        /// 
        /// </param>
        /// <param name="Reset_Device">
        /// 
        /// 
        /// 
        /// 
        /// Reset_Device
        /// ViBoolean
        /// Specifies whether to reset the instrument during the initialization procedure.
        /// 
        /// Defined Values:
        /// 
        /// 
        /// 
        /// VI_TRUE (default)
        /// 1
        /// Reset Device
        /// VI_FALSE
        /// 0
        /// Don't Reset
        /// 
        /// 
        /// </param>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession*
        /// Returns a ViSession handle that you use to identify the instrument in all subsequent instrument driver function calls.
        /// 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        public nidmm(string Resource_Name, bool ID__Query, bool Reset_Device)
        {
            int pInvokeResult = PInvoke.init(Resource_Name, System.Convert.ToUInt16(ID__Query), System.Convert.ToUInt16(Reset_Device), out this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            this._disposed = false;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_InitWithOptions
        /// 
        /// ViStatus = niDMM_InitWithOptions(ViString Resource_Name, ViBoolean ID_Query, ViBoolean Reset_Device, ViString Option_String, ViSession* Instrument_Handle)
        /// 
        /// Purpose
        /// 
        /// This function completes the following tasks:
        /// 
        /// Creates a new IVI instrument driver session and, optionally, sets the initial state of the following session attributes:
        ///  RangeCheck,  QueryInstrStatus,  Cache,  Simulate,  Recordcoercions.
        /// 
        /// Opens a session to the device you specify for the Resource_Name parameter. If the ID_Query parameter is set to VI_TRUE, this function queries the instrument ID and checks that it is valid for this instrument driver. 
        /// 
        /// If the Reset_Device parameter is set to VI_TRUE, this function resets the instrument to a known state. Sends initialization commands to set the instrument to the state necessary for the operation of the instrument driver. 
        /// 
        /// Returns a ViSession handle that you use to identify the instrument in all subsequent instrument driver function calls.
        /// 
        /// </summary>
        /// <param name="Resource_Name">
        /// 
        /// 
        /// 
        /// 
        /// Resource_Name
        /// ViString
        /// Contains the Resource_Name of the device to initialize. The Resource_Name is assigned in Measurement &amp; Automation Explorer (MAX). 
        /// 
        /// Refer to  Related Documentation for the NI&#160;Digital Multimeters Getting Started Guide for more information about configuring and testing the DMM in MAX.
        /// 
        /// Valid Syntax:
        /// 
        /// 
        /// 
        /// NI-DAQmx name
        /// DAQ::NI-DAQmx name[::INSTR]
        /// DAQ::Traditional NI-DAQ device number[::INSTR]
        /// IVI logical name
        /// 
        /// 
        /// Caution&#160;&#160;All IVI names for the Resource_Name, such as logical names or virtual names, are case-sensitive. If you use logical names, driver session names, or virtual names in your program, you must make sure that the name you use matches the name in the IVI Configuration Store file exactly, without any variations in the case of the characters in the name.
        /// 
        /// </param>
        /// <param name="ID__Query">
        /// 
        /// 
        /// 
        /// 
        /// ID_Query
        /// ViBoolean
        /// Verifies that the 
        /// device you initialize is one that the driver supports. NI-DMM 
        /// automatically performs this query, so setting this parameter is not necessary.
        /// 
        /// Defined Values:
        /// 
        /// 
        /// 
        /// VI_TRUE (default)
        /// 1
        /// Perform ID Query
        /// VI_FALSE
        /// 0
        /// Skip ID Query
        /// 
        /// 
        /// </param>
        /// <param name="Reset_Device">
        /// 
        /// 
        /// 
        /// 
        /// Reset_Device
        /// ViBoolean
        /// Specifies whether to reset the instrument during the initialization procedure.
        /// 
        /// Defined Values:
        /// 
        /// 
        /// 
        /// VI_TRUE (default)
        /// 1
        /// Reset Device
        /// VI_FALSE
        /// 0
        /// Don't Reset
        /// 
        /// 
        /// </param>
        /// <param name="Option_String">
        /// 
        /// 
        /// 
        /// 
        /// Option_String
        /// ViString
        /// Sets the initial value of certain attributes for the session. The following table specifies the attribute name, attribute constant, and default value for each attribute that you can use in this parameter:
        /// 
        /// 
        /// 
        /// Check
        /// NIDMM_ATTR_RANGE_CHECK
        /// VI_TRUE
        /// 1
        /// QueryInstrStatus
        /// NIDMM_ATTR_QUERY_INSTR_STATUS
        /// VI_FALSE
        /// 0
        /// Cache
        /// NIDMM_ATTR_CACHE
        /// VI_TRUE
        /// 1
        /// Simulate
        /// NIDMM_ATTR_SIMULATE
        /// VI_FALSE
        /// 0
        /// RecordCoercions
        /// NIDMM_ATTR_RECORD_COERCIONS
        /// VI_FALSE
        /// 0
        /// DriverSetup
        /// NIDMM_ATTR_DRIVER_SETUP
        /// &quot;&quot; (empty string)
        /// &quot;&quot;
        /// The format of this string is, &quot;AttributeName=Value.&quot; To set multiple attributes, separate their assignments with a comma. 
        /// If you pass NULL or an empty string for this parameter, the session uses the default values for the attributes. You can override the default values by assigning a value explicitly in an Option_String parameter. You do not have to specify all of the attributes and may leave any of them out (those left out use the default value).
        /// 
        /// Refer to  Simulating NI&#160;Digital Multimeters for more information.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession*
        /// Returns a ViSession handle that you use to identify the instrument in all subsequent instrument driver function calls.
        /// 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        public nidmm(string Resource_Name, bool ID__Query, bool Reset_Device, string Option_String)
        {
            int pInvokeResult = PInvoke.InitWithOptions(Resource_Name, System.Convert.ToUInt16(ID__Query), System.Convert.ToUInt16(Reset_Device), Option_String, out this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            this._disposed = false;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_InitExtCal
        /// 
        /// ViStatus = niDMM_InitExtCal(ViString Resource_Name, ViChar Calibration_Password[], ViSession *Instrument_Handle)
        /// 
        /// Purpose
        /// 
        /// The following operations are performed if the Calibration_Password is valid:
        /// Creates a new session for external calibration to the device you specify for the Resource_Name parameter. 
        /// Resets the device and prepares the EEPROM for new calibration coefficients.
        /// Returns a ViSession handle that you use to identify the instrument in all calibration adjustments and post-adjustment verification steps.
        /// 
        /// Notes The NI&#160;4050 and NI&#160;4060 are not supported.
        /// 
        /// Refer to the NI&#160;4065 6&#189; Digit DMM Calibration Procedure, the NI&#160;4070/4072 6&#189; Digit FlexDMM Calibration Procedure, or the NI&#160;4071 7&#189;&#8211;Digit FlexDMM Calibration Procedure before using this function.
        /// 
        /// This function creates a new session the first time you invoke it for a device. If you call this function on the same resource, an error is returned. You should use  niDMM_CloseExtCal to close a session obtained using this function.
        /// 
        /// After opening a calibration session, the device cannot take valid measurements using this session until the device has been properly adjusted. Once the adjustment phase is complete, you can use this session to verify the new calibration constants. After verification, you have the option of saving the new calibration constants or reverting to the previous calibration constants by specifying the Action parameter in  niDMM_CloseExtCal.
        /// 
        /// If you encounter a fatal error such as a power failure or system crash while performing an external calibration, you can call  niDMM_RestoreLastExtCalConstants to return the device to a usable state.
        /// 
        /// </summary>
        /// <param name="Resource_Name">
        /// 
        /// 
        /// 
        /// 
        /// Resource_Name
        /// ViString
        /// Contains the Resource_Name of the device to initialize. The Resource_Name is assigned in Measurement &amp; Automation Explorer (MAX). 
        /// 
        /// Refer to  Related Documentation for the NI&#160;Digital Multimeters Getting Started Guide for more information about configuring and testing the DMM in MAX.
        /// 
        /// Valid Syntax:
        /// 
        /// 
        /// 
        /// NI-DAQmx name
        /// DAQ::NI-DAQmx name[::INSTR]
        /// DAQ::Traditional NI-DAQ device number[::INSTR]
        /// IVI logical name
        /// 
        /// 
        /// Caution&#160;&#160;All IVI names for the Resource_Name, such as logical names or virtual names, are case-sensitive. If you use logical names, driver session names, or virtual names in your program, you must make sure that the name you use matches the name in the IVI Configuration Store file exactly, without any variations in the case of the characters in the name.
        /// 
        /// </param>
        /// <param name="Calibration_Password">
        /// 
        /// 
        /// 
        /// 
        /// Calibration_Password
        /// ViChar[]
        /// Specifies the password required to enable external calibration functionality. The maximum password string length is eight characters, excluding the termination character. &quot;NI&quot; is the factory-default password.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// The session handle that you obtain from niDMM_InitExtCal. The handle identifies a particular instrument calibration session.
        /// 
        ///
        /// 
        /// 
        /// </param>
        public nidmm(string Resource_Name, string Calibration_Password)
        {
            int pInvokeResult = PInvoke.InitExtCal(Resource_Name, Calibration_Password, out this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            this._disposed = false;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureMeasurementDigits
        /// 
        /// ViStatus = niDMM_ConfigureMeasurementDigits(ViSession Instrument_Handle, ViInt32 Measurement_Function, ViReal64 Range, ViReal64 Resolution_Digits)
        /// 
        /// Purpose
        /// 
        /// Configures the common attributes of the measurement. These attributes include  NIDMM_ATTR_FUNCTION,  NIDMM_ATTR_RANGE, and  NIDMM_ATTR_RESOLUTION_DIGITS.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Measurement_Function">
        /// 
        /// 
        /// 
        /// 
        /// Measurement_Function
        /// ViInt32
        /// Specifies the Measurement_Function used to acquire the measurement. The driver sets  NIDMM_ATTR_FUNCTION to this value. 
        /// 
        /// 
        /// </param>
        /// <param name="Range">
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Range
        /// 
        /// ViReal64
        /// 
        /// Specifies the range for the function specified in the Measurement_Function parameter. When frequency is specified in the Measurement_Function parameter, you must supply the minimum frequency expected in the Range parameter. For example, you must type in 100 Hz if you are measuring 101 Hz or higher.
        /// 
        /// 
        /// 
        /// For all other functions, you must supply a range that exceeds the value that you are measuring. For example, you must type in 10 V if you are measuring 9 V. Range values are coerced up to the closest input range. Refer to the Devices Overview for a list of valid ranges. The driver sets
        ///  NIDMM_ATTR_RANGE to this value. The default is 0.02 V.
        /// 
        ///  
        /// 
        /// 
        /// Note&#160;&#160;The NI&#160;4050, NI&#160;4060, and NI&#160;4065 only support Auto Range when the trigger and sample trigger are set to IMMEDIATE.
        /// 
        /// 
        /// 
        /// NIDMM_VAL_AUTO_RANGE_ON
        /// -1.0
        /// NI-DMM performs an Auto Range before acquiring the measurement.
        /// 
        /// NIDMM_VAL_AUTO_RANGE_OFF
        /// -2.0
        /// NI-DMM sets the Range to the current  NIDMM_ATTR_AUTO_RANGE_VALUE and uses this range
        ///  for all subsequent measurements until the measurement configuration is changed.
        /// 
        /// NIDMM_VAL_AUTO_RANGE_ONCE
        /// -3.0
        /// NI-DMM performs an Auto Range before acquiring the measurement. The  NIDMM_ATTR_AUTO_RANGE_VALUE is stored and used for all subsequent measurements until the measurement configuration is changed.
        /// 
        /// </param>
        /// <param name="Resolution_Digits">
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Resolution_Digits
        /// 
        /// ViReal64
        /// 
        /// Specifies the resolution of the measurement in digits. The driver sets the Devices Overview for a list of valid ranges. The driver sets
        ///  NIDMM_ATTR_RESOLUTION_DIGITS attribute to this value. This parameter is ignored when the Range parameter is set to NIDMM_VAL_AUTO_RANGE_ON (-1.0) or NIDMM_VAL_AUTO_RANGE_ONCE (-3.0). The default is 5&#189;.
        /// 
        ///  
        /// 
        /// 
        /// Note&#160;&#160;NI-DMM ignores this parameter for capacitance and inductance measurements on the NI&#160;4072. To achieve better resolution for such measurements, use the  NIDMM_ATTR_LC_NUMBER_MEAS_TO_AVERAGE attribute.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureMeasurementDigits(int Measurement_Function, double Range, double Resolution_Digits)
        {
            int pInvokeResult = PInvoke.ConfigureMeasurementDigits(this._handle, Measurement_Function, Range, Resolution_Digits);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureMeasurementAbsolute
        /// 
        /// ViStatus = niDMM_ConfigureMeasurementAbsolute(ViSession Instrument_Handle, ViInt32 Measurement_Function, ViReal64 Range, ViReal64 Resolution_Absolute)
        /// 
        /// Purpose
        /// 
        /// Configures the common attributes of the measurement. These attributes include
        ///  NIDMM_ATTR_FUNCTION,  NIDMM_ATTR_RANGE, and  NIDMM_ATTR_RESOLUTION_ABSOLUTE.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Measurement_Function">
        /// 
        /// 
        /// 
        /// 
        /// Measurement_Function
        /// ViInt32
        /// Specifies the Measurement_Function used to acquire the measurement. The driver sets  NIDMM_ATTR_FUNCTION to this value. 
        /// 
        /// 
        /// </param>
        /// <param name="Range">
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Range
        /// 
        /// ViReal64
        /// 
        /// Specifies the Range for the function specified in the Measurement_Function parameter. When frequency is specified in the Measurement_Function parameter, you must supply the minimum frequency expected in the Range parameter. For example, you must type in 100 Hz if you are measuring 101 Hz or higher.
        /// 
        /// 
        /// 
        /// For all other functions, you must supply a Range that exceeds the value that you are measuring. For example, you must type in 10 V if you are measuring 9 V. Range values are coerced up to the closest input Range. Refer to the Devices Overview for a list of valid ranges.
        /// 
        /// The driver sets  NIDMM_ATTR_RANGE to this value. The default is 0.02 V.
        /// 
        ///  
        /// 
        /// 
        /// Note&#160;&#160;The NI&#160;4050, NI&#160;4060, and NI&#160;4065 only support Auto Range when the trigger and sample trigger are set to IMMEDIATE.
        /// 
        /// 
        /// 
        /// NIDMM_VAL_AUTO_RANGE_ON
        /// -1.0
        /// NI-DMM performs an Auto Range before acquiring the measurement.
        /// 
        /// NIDMM_VAL_AUTO_RANGE_OFF
        /// -2.0
        /// NI-DMM sets the Range to the current  NIDMM_ATTR_AUTO_RANGE_VALUE and uses this range
        ///  for all subsequent measurements until the measurement configuration is changed.
        /// 
        /// NIDMM_VAL_AUTO_RANGE_ONCE
        /// -3.0
        /// NI-DMM performs an Auto Range before acquiring the measurement. The  NIDMM_ATTR_AUTO_RANGE_VALUE is stored and used for all subsequent measurements until the measurement configuration is changed.
        /// 
        /// </param>
        /// <param name="Resolution_Absolute">
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Resolution_Absolute
        /// 
        /// ViReal64
        /// 
        /// Specifies the absolute resolution for the measurement. NI-DMM sets  NIDMM_ATTR_RESOLUTION_ABSOLUTE to this value. This parameter is ignored when the Range parameter is set to NIDMM_VAL_AUTO_RANGE_ON (-1.0) or NIDMM_VAL_AUTO_RANGE_ONCE (-3.0). The default is 0.001 V.
        /// 
        ///  
        /// 
        /// 
        /// Note&#160;&#160;NI-DMM ignores this parameter for capacitance and inductance measurements on the NI 4072. To achieve better resolution for such measurements, use the  NIDMM_ATTR_LC_NUMBER_MEAS_TO_AVERAGE attribute.
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureMeasurementAbsolute(int Measurement_Function, double Range, double Resolution_Absolute)
        {
            int pInvokeResult = PInvoke.ConfigureMeasurementAbsolute(this._handle, Measurement_Function, Range, Resolution_Absolute);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureMultiPoint
        /// 
        /// ViStatus = niDMM_ConfigureMultiPoint(ViSession Instrument_Handle, ViInt32 Trigger_Count, ViInt32 Sample_Count, ViInt32 Sample_Trigger, ViReal64 Sample_Interval)
        /// 
        /// Purpose
        /// 
        /// Configures the attributes for multipoint measurements. These attributes include 
        ///  NIDMM_ATTR_TRIGGER_COUNT, 
        ///  NIDMM_ATTR_SAMPLE_COUNT, 
        ///  NIDMM_ATTR_SAMPLE_TRIGGER, and 
        ///  NIDMM_ATTR_SAMPLE_TRIGGER.
        /// 
        /// For continuous acquisitions, set 
        ///  NIDMM_ATTR_TRIGGER_COUNT or 
        ///  NIDMM_ATTR_SAMPLE_COUNT to zero. For more information, refer to 
        /// Multiple Point Acquisitions, 
        /// Triggering, and 
        /// Using Switches.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Trigger_Count">
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Trigger_Count
        /// ViInt32
        /// Sets the number of triggers you want the DMM to receive before returning to the Idle state. The driver sets  NIDMM_ATTR_TRIGGER_COUNT to this value. The default value is 1.
        /// 
        /// </param>
        /// <param name="Sample_Count">
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Sample_Count
        /// ViInt32
        /// Sets the number of measurements the DMM makes in each measurement sequence initiated by a trigger. The driver sets  NIDMM_ATTR_SAMPLE_COUNT to this value. The default value is 1.
        /// </param>
        /// <param name="Sample_Trigger">
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Sample_Trigger
        /// ViInt32
        /// Specifies the Sample_Trigger source you want to use. The driver sets 
        ///  
        /// NIDMM_ATTR_SAMPLE_TRIGGER to this value. The default is Immediate.
        /// 
        /// 
        /// 
        /// 
        /// Note&#160;&#160;To determine which values are supported by each device, refer to the LabWindows/CVI Trigger Routing section.
        /// 
        /// </param>
        /// <param name="Sample_Interval">
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Sample_Interval
        /// ViReal64
        /// Sets the amount of time in seconds the DMM waits between measurements. The driver sets 
        ///  
        /// NIDMM_ATTR_SAMPLE_INTERVAL to this value. Specify a sample interval to add settling time between measurements or to decrease the measurement rate. Sample_Interval only applies when the Sample_Trigger is set to INTERVAL.On the NI&#160;4060, the Sample_Interval value is used as the settling time. When sample interval is set to 0, the DMM does not settle between measurements. The NI&#160;4065 and NI&#160;4070/4071/4072 use the value specified in Sample_Interval as additional delay. The default value (-1) ensures that the DMM settles for a recommended time. This is the same as using an Immediate trigger.
        /// 
        /// 
        /// Note&#160;&#160;This attribute is not used on the NI&#160;4050.
        /// 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureMultiPoint(int Trigger_Count, int Sample_Count, int Sample_Trigger, double Sample_Interval)
        {
            int pInvokeResult = PInvoke.ConfigureMultiPoint(this._handle, Trigger_Count, Sample_Count, Sample_Trigger, Sample_Interval);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureWaveformAcquisition
        /// 
        /// ViStatus = niDMM_ConfigureWaveformAcquisition(ViSession Instrument_Handle, ViInt32 Measurement_Function, ViReal64 Range, ViReal64 Rate, ViInt32 Waveform_Points)
        /// 
        /// Purpose
        /// 
        /// Configures the NI&#160;4070/4071/4072 for waveform acquisitions.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Measurement_Function">
        /// 
        /// 
        /// 
        /// 
        /// Measurement_Function
        /// ViInt32
        /// Specifies the Measurement_Function used in a waveform acquisition. The driver sets 
        ///  
        /// NIDMM_ATTR_FUNCTION to this value.
        /// 
        /// 
        /// 
        /// NIDMM_VAL_WAVEFORM_VOLTAGE (default)
        /// 1003
        /// Voltage Waveform
        /// NIDMM_VAL_WAVEFORM_CURRENT
        /// 1004
        /// Current Waveform
        /// 
        /// </param>
        /// <param name="Range">
        /// 
        /// 
        /// 
        /// 
        /// Range
        /// ViReal64
        /// Specifies the expected maximum amplitude of the input signal and sets the Range for the Measurement_Function. NI-DMM sets 
        ///  
        /// NIDMM_ATTR_RANGE to this value. Range values are coerced up to the closest input Range. The default is 10.0. 
        /// 
        /// For valid ranges refer to the topics in 
        /// Devices.
        /// 
        /// Auto-ranging is not supported during waveform acquisitions.
        /// 
        /// 
        /// </param>
        /// <param name="Rate">
        /// 
        /// 
        /// 
        /// 
        /// Rate
        /// ViReal64
        /// Specifies the Rate of the acquisition in samples per second. NI-DMM sets 
        ///  
        /// NIDMM_ATTR_WAVEFORM_RATE to this value. 
        /// 
        /// The valid Range is 10.0&#8211;1,800,000 S/s. Rate values are coerced to the closest integer divisor of 1,800,000. The default value is 1,800,000.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Waveform_Points">
        /// 
        /// 
        /// 
        /// 
        /// Waveform_Points
        /// ViInt32
        /// Specifies the number of points to acquire before the waveform acquisition completes. NI-DMM sets 
        ///  
        /// NIDMM_ATTR_WAVEFORM_POINTS to this value. To calculate the maximum and minimum number of waveform points that you can acquire in one acquisition, refer to the 
        /// Waveform Acquisition Measurement Cycle.The default value is 500.   
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureWaveformAcquisition(int Measurement_Function, double Range, double Rate, int Waveform_Points)
        {
            int pInvokeResult = PInvoke.ConfigureWaveformAcquisition(this._handle, Measurement_Function, Range, Rate, Waveform_Points);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureCableCompType
        /// 
        /// ViStatus = niDMM_ConfigureCableCompType(ViSession Instrument_Handle, ViInt32 Cable_Comp_Type)
        /// 
        /// Purpose
        /// 
        /// For the NI&#160;4072 only, sets the 
        ///  NIDMM_ATTR_CABLE_COMPENSATION_TYPE attribute for the current capacitance/inductance mode range.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Cable_Comp_Type">
        /// 
        /// 
        /// 
        /// Cable_Comp_Type
        /// ViInt32
        /// Specifies the type of cable compensation that is used for the current range.
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureCableCompType(int Cable_Comp_Type)
        {
            int pInvokeResult = PInvoke.ConfigureCableCompType(this._handle, Cable_Comp_Type);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureOpenCableCompValues
        /// 
        /// ViStatus = niDMM_ConfigureOpenCableCompValues(ViSession Instrument_Handle, ViReal64 Conductance, ViReal64 Susceptance)
        /// 
        /// Purpose
        /// 
        /// For the NI&#160;4072 only, configures the 
        ///  NIDMM_ATTR_OPEN_CABLE_COMP_CONDUCTANCE 
        /// and 
        ///  NIDMM_ATTR_OPEN_CABLE_COMP_SUSCEPTANCE attributes.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Conductance">
        /// 
        /// 
        /// 
        /// 
        /// Conductance
        /// ViReal64
        /// Specifies the open cable compensation Conductance. 
        /// 
        /// </param>
        /// <param name="Susceptance">
        /// 
        /// 
        /// 
        /// 
        /// Susceptance
        /// ViReal64
        /// Specifies the open cable compensation Susceptance.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureOpenCableCompValues(double Conductance, double Susceptance)
        {
            int pInvokeResult = PInvoke.ConfigureOpenCableCompValues(this._handle, Conductance, Susceptance);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureShortCableCompValues
        /// 
        /// ViStatus = niDMM_ConfigureShortCableCompValues(ViSession Instrument_Handle, ViReal64 Resistance, ViReal64 Reactance)
        /// 
        /// Purpose
        /// 
        /// For the NI&#160;4072 only, configures the 
        /// NIDMM_ATTR_SHORT_CABLE_COMP_RESISTANCE and 
        /// NIDMM_ATTR_SHORT_CABLE_COMP_REACTANCE attributes.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Resistance">
        /// 
        /// 
        /// 
        /// Resistance
        /// ViReal64
        /// Specifies the short cable compensation Resistance.
        /// 
        /// </param>
        /// <param name="Reactance">
        /// 
        /// 
        /// 
        /// Reactance
        /// ViReal64
        /// Specifies the short cable compensation Reactance.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureShortCableCompValues(double Resistance, double Reactance)
        {
            int pInvokeResult = PInvoke.ConfigureShortCableCompValues(this._handle, Resistance, Reactance);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_PerformOpenCableComp
        /// 
        /// ViStatus = niDMM_PerformOpenCableComp(ViSession Instrument_Handle, ViReal64 *Conductance, ViReal64 *Susceptance)
        /// 
        /// Purpose
        /// 
        /// For the NI&#160;4072 only, performs the open cable compensation measurements for the current capacitance/inductance range, and returns open cable compensation Conductance and Susceptance values. You can use the return values of this function as inputs to 
        ///  
        /// niDMM_ConfigureOpenCableCompValues.
        /// 
        /// This function returns an error if the value of the 
        ///  
        /// NIDMM_ATTR_FUNCTION attribute is not set to NIDMM_VAL_CAPACITANCE (1005) or NIDMM_VAL_INDUCTANCE (1006).
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Conductance">
        /// 
        /// 
        /// 
        /// 
        /// Conductance
        /// ViReal64*
        /// Conductance is the measured value of open cable compensation Conductance.
        /// </param>
        /// <param name="Susceptance">
        /// 
        /// 
        /// 
        /// 
        /// Susceptance
        /// ViReal64*
        /// Susceptance is the measured value of open cable compensation Susceptance.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int PerformOpenCableComp(out double Conductance, out double Susceptance)
        {
            int pInvokeResult = PInvoke.PerformOpenCableComp(this._handle, out Conductance, out Susceptance);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_PerformShortCableComp
        /// 
        /// ViStatus = niDMM_PerformShortCableComp(ViSession Instrument_Handle, ViReal64 *Resistance, ViReal64 *Reactance)
        /// 
        /// 
        /// Purpose
        /// 
        /// Performs the short cable compensation measurements for the current capacitance/inductance range, and returns short cable compensation Resistance and Reactance values. You can use the return values of this function as inputs to 
        ///  
        /// niDMM_ConfigureShortCableCompValues.
        /// 
        /// This function returns an error if the value of the 
        ///  
        /// NIDMM_ATTR_FUNCTION attribute is not set to NIDMM_VAL_CAPACITANCE (1005) or NIDMM_VAL_INDUCTANCE (1006).
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Resistance">
        /// 
        /// 
        /// 
        /// 
        /// Resistance
        /// ViReal64*
        /// Resistance is the measured value of short cable compensation Resistance.
        /// 
        /// </param>
        /// <param name="Reactance">
        /// 
        /// 
        /// 
        /// 
        /// Reactance
        /// ViReal64*
        /// Reactance is the measured value of short cable compensation Reactance.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int PerformShortCableComp(out double Resistance, out double Reactance)
        {
            int pInvokeResult = PInvoke.PerformShortCableComp(this._handle, out Resistance, out Reactance);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureTransducerType
        /// 
        /// ViStatus = niDMM_ConfigureTransducerType (ViSession Instrument_Handle, ViInt32 Transducer_Type)
        /// 
        /// 
        /// Purpose
        /// 
        /// Configures the transducer type.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Transducer_Type">
        /// 
        /// 
        /// 
        /// 
        /// Transducer_Type
        /// ViInt32
        /// Specifies the type of device used to measure the temperature. NI-DMM uses this value to set the Transducer Type  property. The default is NIDMM_VAL_THERMOCOUPLE.
        /// 
        /// 
        /// NIDMM_VAL_2_WIRE_RTD  2-wire RTD
        /// NIDMM_VAL_4_WIRE_RTD  4-wire RTD
        /// NIDMM_VAL_THERMISTOR    Thermistor
        /// NIDMM_VAL_THERMOCOUPLE  Thermocouple
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureTransducerType(int Transducer_Type)
        {
            int pInvokeResult = PInvoke.ConfigureTransducerType(this._handle, Transducer_Type);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureThermocouple
        /// 
        /// ViStatus = niDMM_ConfigureThermocouple(ViSession Instrument_Handle, ViInt32 Thermocouple_Type, ViInt32 Reference_Junction_Type)
        /// 
        /// 
        /// Purpose
        /// 
        /// Configures the thermocouple type and reference junction type for a chosen thermocouple.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Thermocouple_Type">
        /// 
        /// 
        /// 
        /// Thermocouple_Type
        /// ViInt32
        /// Specifies the type of thermocouple used to measure the temperature. NI-DMM uses this value to set the Thermocouple Type property. The default is NIDMM_VAL_TEMP_TC_J.
        /// 
        /// 
        /// 
        /// 
        /// NIDMM_VAL_TEMP_TC_B   Thermocouple type B
        /// NIDMM_VAL_TEMP_TC_E   Thermocouple type E
        /// NIDMM_VAL_TEMP_TC_J   Thermocouple type J
        /// NIDMM_VAL_TEMP_TC_K   Thermocouple type K
        /// NIDMM_VAL_TEMP_TC_N   Thermocouple type N
        /// NIDMM_VAL_TEMP_TC_R   Thermocouple type R
        /// NIDMM_VAL_TEMP_TC_S   Thermocouple type S
        /// NIDMM_VAL_TEMP_TC_T   Thermocouple type T
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Reference_Junction_Type">
        /// 
        /// 
        /// 
        /// 
        /// Reference_Junction_Type
        /// ViInt32
        ///  Specifies the type of reference junction to be used in the reference junction compensation of a thermocouple measurement. NI-DMM uses this value to set the Reference Junction Type property. The only supported value is NIDMM_VAL_TEMP_REF_JUNC_FIXED.
        /// 
        /// NIDMM_VAL_TEMP_REF_JUNC_FIXED
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureThermocouple(int Thermocouple_Type, int Reference_Junction_Type)
        {
            int pInvokeResult = PInvoke.ConfigureThermocouple(this._handle, Thermocouple_Type, Reference_Junction_Type);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureFixedRefJunction
        /// 
        /// ViStatus = niDMM_ConfigureFixedRefJunction(ViSession Instrument_Handle, ViReal64 Fixed_Reference_Junction)
        /// 
        /// 
        /// Purpose
        /// 
        /// Configures the fixed reference junction temperature for a thermocouple with a fixed reference junction type.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Fixed_Reference_Junction">
        /// 
        /// 
        /// 
        /// 
        /// Fixed_Reference_Junction
        /// ViReal64
        ///  Specifies the reference junction temperature when a fixed reference junction is used to take a thermocouple measurement.  The units are degrees Celsius. NI-DMM uses this value to set the Fixed Reference Junction property. The default is 25.00 (&#176;C). 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureFixedRefJunction(double Fixed_Reference_Junction)
        {
            int pInvokeResult = PInvoke.ConfigureFixedRefJunction(this._handle, Fixed_Reference_Junction);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureRTDType
        /// 
        /// ViStatus = niDMM_ConfigureRTDType(ViSession Instrument_Handle, ViInt32 RTD_Type, ViReal64 RTD_Resistance)
        /// 
        /// 
        /// Purpose
        /// 
        /// Configures the RTD Type and RTD Resistance parameters for an RTD.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="RTD_Type">
        /// 
        /// 
        /// 
        /// 
        /// RTD_Type
        /// ViInt32
        /// Specifies the type of RTD used to measure the temperature resistance. NI-DMM uses this value to set the RTD Type property. The default is NIDMM_VAL_TEMP_RTD_PT3851.
        /// 
        ///  
        /// 
        ///  
        ///     Enum
        ///   Standards
        ///   Material
        ///    TCR (&#945;)
        ///   Typical R0 (&#0937;) 
        ///   Callendar-Van Dusen Coefficient
        ///   Notes
        /// 
        ///   
        /// 
        ///      NIDMM_VAL_TEMP_RTD_PT3851 
        ///    IEC-751
        ///  DIN 43760 
        ///  BS 1904 
        ///  ASTM-E1137 
        ///  EN-60751 
        ///    Platinum 
        ///    .003851
        ///    100 &#0937; 
        ///  1000 &#0937;
        ///    A = 3.9083 X 10&#8211;3 
        ///  B = &#8211;5.775X10&#8211;7 
        ///  C = &#8211;4.183X10&#8211;12
        ///    Most common RTDs
        ///   
        /// 
        ///      NIDMM_VAL_TEMP_RTD_PT3750 
        ///    Low-cost vendor compliant RTD* 
        ///    Platinum 
        ///   .003750 
        ///    1000 &#0937;
        ///    A = 3.81 X 10&#8211;3 
        ///  B = &#8211;6.02X10&#8211;7 
        ///  C = &#8211;6.0X10&#8211;12
        ///    Low-cost RTD
        ///   
        /// 
        ///         NIDMM_VAL_TEMP_RTD_PT3916 
        ///    JISC 1604 
        ///    Platinum 
        ///   .003916 
        ///    100 &#0937;
        ///    A = 3.9739 X 10&#8211;3 
        ///  B = &#8211;5.870X10&#8211;7 
        ///  C = &#8211;4.4 X10&#8211;12
        ///    Used in primarily in Japan
        ///   
        /// 
        ///                NIDMM_VAL_TEMP_RTD_PT3920 
        ///    US Industrial Standard D-100 
        ///  American 
        ///    Platinum 
        ///   .003920
        ///    100 &#0937;
        ///    A = 3.9787 X 10&#8211;3 
        ///  B = &#8211;5.8686X10&#8211;7 
        ///  C = &#8211;4.167 X10&#8211;12
        ///    Low-cost RTD
        ///   
        /// 
        ///          NIDMM_VAL_TEMP_RTD_PT3911 
        ///    US Industrial Standard 
        ///  American 
        ///    Platinum 
        ///   .003911
        ///    100 &#0937;
        ///    A = 3.9692 X 10&#8211;3 
        ///  B = &#8211;5.8495X10&#8211;7 
        ///  C = &#8211;4.233 X10&#8211;12
        ///    Low-cost RTD
        ///   
        /// 
        ///              NIDMM_VAL_TEMP_RTD_PT3928 
        ///    ITS-90 
        ///    Platinum 
        ///   .003928
        ///    100 &#0937;
        ///    A = 3.9888 X 10&#8211;3 
        ///  B = &#8211;5.915X10&#8211;7 
        ///  C = &#8211;3.85 X10&#8211;12
        ///    The definition of temperature
        ///   
        /// 
        ///       *No standard. Check the TCR. 
        /// 
        ///   
        ///   
        ///   
        ///   
        /// 
        /// </param>
        /// <param name="RTD_Resistance">
        /// 
        /// 
        /// 
        /// 
        /// RTD_Resistance
        /// ViReal64
        /// Specifies the RTD resistance in ohms at 0 &#176;C. NI-DMM uses this value to set the RTD Resistance property. The default is 100 (&#8486;).
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureRTDType(int RTD_Type, double RTD_Resistance)
        {
            int pInvokeResult = PInvoke.ConfigureRTDType(this._handle, RTD_Type, RTD_Resistance);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureRTDCustom
        /// 
        /// ViStatus = niDMM_ConfigureRTDCustom(ViSession Instrument_Handle, ViReal64 RTD_A, ViReal64 RTD_B, ViReal64 RTD_C)
        /// 
        /// 
        /// Purpose
        /// 
        /// Configures the  A, B, and C parameters for a custom RTD.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="RTD_A">
        /// 
        /// 
        /// 
        /// 
        /// RTD_A
        /// ViReal64
        /// Specifies the Callendar-Van Dusen A coefficient for RTD scaling when RTD Type parameter is set to Custom in the  niDMM_ConfigureRTDType function. The default is 3.9083e-3 (Pt3851)
        /// 
        /// 
        /// </param>
        /// <param name="RTD_B">
        /// 
        /// 
        /// 
        /// 
        /// RTD_B
        /// ViReal64
        /// Specifies the Callendar-Van Dusen B coefficient for RTD scaling when RTD Type parameter is set to Custom in the  niDMM_ConfigureRTDType function. The default is -5.775e-7 (Pt3851).
        /// 
        /// 
        /// </param>
        /// <param name="RTD_C">
        /// 
        /// 
        /// 
        /// 
        /// RTD_C
        /// ViReal64
        /// Specifies the Callendar-Van Dusen C coefficient for RTD scaling when RTD Type parameter is set to Custom  in the  niDMM_ConfigureRTDType function. The default is -4.183e-12 (Pt3851).
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureRTDCustom(double RTD_A, double RTD_B, double RTD_C)
        {
            int pInvokeResult = PInvoke.ConfigureRTDCustom(this._handle, RTD_A, RTD_B, RTD_C);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureThermistorType
        /// 
        /// ViStatus = niDMM_ConfigureThermistorType(ViSession Instrument_Handle, ViInt32 Thermistor_Type)
        /// 
        /// 
        /// Purpose
        /// 
        /// Configures the thermistor type.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Thermistor_Type">
        /// 
        /// 
        /// 
        ///  Specifies the type of thermistor used to measure the temperature. NI-DMM uses this value to set the Thermistor Type property. The default is NIDMM_VAL_TEMP_THERMISTOR_44006.
        /// Defined Values
        /// Thermistor Type
        /// Value
        /// 25 &#176;C Resistance
        /// 
        ///         
        ///             NIDMM_VAL_TEMP_THERMISTOR_CUSTOM
        /// Custom
        /// 0
        /// &#8212;
        ///                             NIDMM_VAL_TEMP_THERMISTOR_44004
        /// 44004
        /// 1
        /// 2.25 k&#0937;
        ///                         NIDMM_VAL_TEMP_THERMISTOR_44006
        /// 44006
        /// 2
        /// 
        /// 10 k&#0937;
        ///                         NIDMM_VAL_TEMP_THERMISTOR_44007
        /// 44007
        /// 3
        /// 5 k&#0937;
        ///  
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureThermistorType(int Thermistor_Type)
        {
            int pInvokeResult = PInvoke.ConfigureThermistorType(this._handle, Thermistor_Type);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureThermistorCustom
        /// 
        /// ViStatus = niDMM_ConfigureThermistorCustom(ViSession Instrument_Handle, ViReal64 Thermistor_A, ViReal64 Thermistor_B, ViReal64 Thermistor_C)
        /// 
        /// 
        /// Purpose
        /// 
        /// Configures the  A, B, and C parameters for a custom thermistor.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Thermistor_A">
        /// 
        /// 
        /// 
        /// 
        /// Thermistor_A
        /// ViReal64
        /// Specifies  the Steinhart-Hart A coefficient for thermistor scaling when Thermistor Type is set to Custom in the  
        ///  niDMM_ConfigureThermistorType function. The default is 1.0295e-3 (44006).
        /// 
        /// 
        /// </param>
        /// <param name="Thermistor_B">
        /// 
        /// 
        /// 
        /// 
        /// Thermistor_B
        /// ViReal64
        /// Specifies the Steinhart-Hart B coefficient for thermistor scaling when Thermistor Type is set to Custom in the 
        ///  niDMM_ConfigureThermistorType function. The default is 2.391e-4 (44006).
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Thermistor_C">
        /// 
        /// 
        /// 
        /// 
        /// Thermistor_C
        /// ViReal64
        /// Specifies the Steinhart-Hart C coefficient for thermistor scaling when Thermistor Type is set to Custom in the 
        ///  niDMM_ConfigureThermistorType function. The default is 1.568e-7 (44006).
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureThermistorCustom(double Thermistor_A, double Thermistor_B, double Thermistor_C)
        {
            int pInvokeResult = PInvoke.ConfigureThermistorCustom(this._handle, Thermistor_A, Thermistor_B, Thermistor_C);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigurePowerLineFrequency
        /// 
        /// ViStatus = niDMM_ConfigurePowerLineFrequency(ViSession Instrument_Handle, ViReal64 Power_Line_Frequency_Hz)
        /// 
        /// Purpose
        /// 
        /// Specifies the powerline frequency. 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Power_Line_Frequency_Hz">
        /// 
        /// 
        /// 
        /// 
        ///    Power Line Frequency Hz
        ///   ViReal64*
        ///   Powerline Frequency specifies the powerline frequency in hertz.  
        ///    NI-DMM sets the Powerline Frequency property to this value. 
        ///                                       50 HERTZ
        ///                     50 Hz
        ///                 
        ///                                     60 HERTZ
        ///                     60 Hz
        ///                 
        ///   
        ///          
        ///     Note??You should set this control to the frequency of the AC power line (for 400 Hz power line use the 50 Hz setting).
        ///    
        ///   
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigurePowerLineFrequency(double Power_Line_Frequency_Hz)
        {
            int pInvokeResult = PInvoke.ConfigurePowerLineFrequency(this._handle, Power_Line_Frequency_Hz);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureAutoZeroMode
        /// 
        /// ViStatus = niDMM_ConfigureAutoZeroMode(ViSession Instrument_Handle, ViInt32 Auto_Zero_Mode)
        /// 
        /// 
        /// Purpose
        /// 
        /// Configures the DMM for Auto_Zero_Mode. When Auto_Zero_Mode is ON, the DMM internally disconnects the input signal and takes a zero reading. It then subtracts the zero reading from the measurement. This prevents offset voltages present on the input circuitry of the DMM from affecting measurement accuracy. When Auto_Zero_Mode is OFF, the DMM does not compensate for zero reading offset.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Auto_Zero_Mode">
        /// 
        /// 
        /// 
        /// 
        /// Auto_Zero_Mode
        /// ViInt32
        /// Specifies the Auto_Zero_Mode. NI-DMM sets the  NIDMM_ATTR_AUTO_ZERO attribute to this value. 
        /// 
        /// ON enables Auto_Zero_Mode for each measurement. ONCE enables Auto_Zero_Mode before the next measurement. The Auto_Zero_Mode value is stored and used in subsequent measurements until the device is reconfigured.
        /// 
        /// OFF disables Auto_Zero_Mode. If you set this parameter to AUTO, NI-DMM determines whether to enable Auto Zero based on the measurement function that you configure. If you configure the NI&#160;4070/4071/4072 for a 6&#189;&#8211;digit and greater resolution DC measurement, NI-DMM sets Auto_Zero_Mode to ON.
        /// 
        /// For all other DC measurement configurations on the NI&#160;4070/4071/4072, NI-DMM sets Auto_Zero_Mode to ONCE. For all AC measurements or waveform acquisitions on the NI&#160;4070/4071/4072, NI-DMM sets Auto_Zero_Mode to OFF. For NI&#160;4060, Auto_Zero_Mode is set to OFF when AUTO is selected.
        /// 
        /// For NI 4065 devices, Auto_Zero_Mode is always ON. Auto_Zero_Mode is an integral part of the signal measurement phase and adds no extra time to the overall measurement.
        /// 
        /// NIDMM_VAL_AUTO_ZERO_AUTO&#160;(default)
        /// -1
        /// NI-DMM chooses the Auto Zero setting based on the configured function and resolution.
        /// NIDMM_VAL_AUTO_ZERO_OFF
        /// &#160;0
        /// Disables Auto Zero.
        /// Note&#160;&#160;The NI 4065 does not support this setting.
        /// NIDMM_VAL_AUTO_ZERO_ON
        /// &#160;1
        /// The DMM internally disconnects the input signal following each measurement and takes a zero reading. It then subtracts the zero reading from the preceding reading.
        /// 
        /// 
        /// Note&#160;&#160;For NI 4065 devices, Auto_Zero_Mode is always ON. Auto_Zero_Mode is an integral part of the signal measurement phase and adds no extra time to the overall measurement.
        /// NIDMM_VAL_AUTO_ZERO_ONCE
        /// &#160;2
        /// The DMM internally disconnects the input signal following each measurement and takes a zero reading. It then subtracts the zero reading from the preceding reading.
        /// 
        /// 
        /// Note&#160;&#160;The NI 4060/4065 does not support this setting.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureAutoZeroMode(int Auto_Zero_Mode)
        {
            int pInvokeResult = PInvoke.ConfigureAutoZeroMode(this._handle, Auto_Zero_Mode);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureADCCalibration
        /// 
        /// ViStatus = niDMM_ConfigureADCCalibration(ViSession Instrument_Handle, ViInt32 ADC_Calibration)
        /// 
        /// Purpose
        /// 
        /// For the NI&#160;4070/4071/4072 only, allows the DMM to compensate for gain drift since the last external calibration or self-calibration. When ADC_Calibration is ON, the DMM measures an internal reference to calculate the correct gain for the measurement. When ADC_Calibration is OFF, the DMM does not compensate for changes to the gain.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="ADC__Calibration">
        /// 
        /// 
        /// 
        /// 
        /// ADC_Calibration
        /// ViInt32
        /// Specifies the ADC_Calibration setting. The driver sets 
        ///  NIDMM_ATTR_ADC_CALIBRATION to this value. 
        /// 
        /// 
        /// 
        /// NIDMM_VAL_ADC_CALIBRATION_ON enables ADC_Calibration. 
        /// NIDMM_VAL_ADC_CALIBRATION_OFF disables ADC_Calibration.
        /// 
        /// If you set the value to NIDMM_VAL_ADC_CALIBRATION_AUTO, the driver determines whether to enable ADC_Calibration based on the measurement function and resolution that you configure. If you configure the NI&#160;4070/4071/4072 for a 6&#189;&#8211;digit and greater resolution DC measurement, the driver enables ADC Calibration. For all other measurement configurations, the driver disables ADC_Calibration.
        /// 
        /// 
        /// 
        /// NameValueDescription
        /// NIDMM_VAL_ADC_CALIBRATION_AUTO&#160;(default)
        /// -1.0
        /// The DMM enables or disables ADC_Calibration based on the configured function and resolution.
        /// NIDMM_VAL_ADC_CALIBRATION_OFF
        /// &#160;0
        /// The DMM does not compensate for changes to the gain.
        /// NIDMM_VAL_ADC_CALIBRATION_ON
        /// &#160;1
        /// The DMM measures an internal reference to calculate the correct gain for the measurement.
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureADCCalibration(int ADC__Calibration)
        {
            int pInvokeResult = PInvoke.ConfigureADCCalibration(this._handle, ADC__Calibration);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureOffsetCompOhms
        /// 
        /// ViStatus = niDMM_ConfigureOffsetCompOhms(ViSession Instrument_Handle, ViInt32 Offset_Comp_Ohms)
        /// 
        /// Purpose
        /// 
        /// For NI&#160;4070/4071/4072 only, allows the DMM to compensate for voltage offsets in resistance measurements. When Offset_Comp_Ohms is enabled, the DMM measures the resistance twice (once with the current source on and again with it turned off). Any voltage offset present in both measurements is cancelled out. Offset_Comp_Ohms is useful when measuring resistance values less than 10 K&#937;;.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Offset_Comp_Ohms">
        /// 
        /// 
        /// 
        /// 
        /// Offset_Comp_Ohms
        /// ViInt32
        /// Enables or disables Offset_Comp_Ohms. The driver sets  NIDMM_ATTR_OFFSET_COMP_OHMS to this value. 
        /// 
        /// 
        /// 
        /// NameValueDescription
        /// NIDMM_VAL_OFFSET_COMP_OHMS_OFF&#160;(default)
        /// 0
        /// Off&#160;disables&#160;Offset_Comp_Ohms.
        /// NIDMM_VAL_OFFSET_COMP_OHMS_ON
        /// 1
        /// On enables Offset_Comp_Ohms.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureOffsetCompOhms(int Offset_Comp_Ohms)
        {
            int pInvokeResult = PInvoke.ConfigureOffsetCompOhms(this._handle, Offset_Comp_Ohms);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureACBandwidth
        /// 
        /// ViStatus = niDMM_ConfigureACBandwidth(ViSession Instrument_Handle, ViReal64 AC_Minimum_Frequency_Hz, ViReal64 AC_Maximum_Frequency_Hz)
        /// 
        /// Purpose
        /// 
        /// Configures the 
        ///  
        /// NIDMM_ATTR_AC_MIN_FREQ 
        /// and 
        ///  
        /// NIDMM_ATTR_AC_MAX_FREQ attributes, which the DMM uses for AC measurements.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="AC__Minimum_Frequency_Hz">
        /// 
        /// 
        /// 
        /// 
        /// AC_Minimum_Frequency_Hz
        /// ViReal64
        /// Specifies the minimum expected frequency component of the input signal in hertz. This parameter affects the DMM only when you set the 
        ///  NIDMM_ATTR_FUNCTION attribute to AC measurements. NI-DMM uses this parameter to calculate the proper aperture for the measurement.
        /// 
        /// The driver sets the 
        ///  
        /// NIDMM_ATTR_FUNCTION attribute to this value. The valid range is 1 Hz&#8211;300 kHz for the NI 4070/4071/4072, 10 Hz&#8211;100 Hz for the NI&#160;4065, and 20 Hz&#8211;25 kHz for the NI 4050 and NI 4060.
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="AC__Maximum_Frequency_Hz">
        /// 
        /// 
        /// 
        /// 
        /// AC_Maximum_Frequency_Hz
        /// ViReal64
        /// Specifies the maximum expected frequency component of the input signal in hertz within the device limits. This parameter is used only for error checking and verifies that the value of this parameter is less than the maximum frequency of the device. This parameter affects the DMM only when you set the 
        ///  
        /// NIDMM_ATTR_FUNCTION attribute to AC measurements. The driver sets the 
        ///  NIDMM_ATTR_AC_MAX_FREQ attribute to this value. The valid range is 1 Hz&#8211;300 kHz for the NI 4070/4071/4072, 10 Hz&#8211;100 Hz for the NI&#160;4065, and 20 Hz&#8211;25 kHz for the NI 4050 and NI 4060.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureACBandwidth(double AC__Minimum_Frequency_Hz, double AC__Maximum_Frequency_Hz)
        {
            int pInvokeResult = PInvoke.ConfigureACBandwidth(this._handle, AC__Minimum_Frequency_Hz, AC__Maximum_Frequency_Hz);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureFrequencyVoltageRange
        /// 
        /// ViStatus = niDMM_ConfigureFrequencyVoltageRange(ViSession Instrument_Handle, ViReal64 Voltage_Range)
        /// 
        /// Purpose
        /// 
        /// For the NI&#160;4070/4071/4072 only, specifies the expected maximum amplitude of the input signal for frequency and period measurements.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Voltage_Range">
        /// 
        /// 
        /// 
        /// 
        /// Voltage_Range
        /// ViReal64
        /// Sets the expected maximum amplitude of the input signal. Refer to the 
        /// NI&#160;4070, 
        /// NI&#160;4071, and 
        /// NI&#160;4072 sections for a list of valid values. NI-DMM sets 
        ///  NIDMM_ATTR_FREQ_VOLTAGE_RANGE to this value. The minimum peak-to-peak signal amplitude that can be detected is 10% of the specified Voltage_Range.
        /// 
        /// 
        /// 
        /// NameValueDescription
        /// NIDMM_VAL_AUTO_RANGE_ON&#160;(default)
        /// -1.0
        /// Configures the DMM to take an Auto Range measurement to calculate the voltage range before each frequency or period measurement.
        /// NIDMM_VAL_AUTO_RANGE_OFF
        /// -2.0
        /// Disables Auto Ranging. The driver sets the voltage range to the last calculated voltage range.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureFrequencyVoltageRange(double Voltage_Range)
        {
            int pInvokeResult = PInvoke.ConfigureFrequencyVoltageRange(this._handle, Voltage_Range);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureCurrentSource
        /// 
        /// ViStatus = niDMM_ConfigureCurrentSource(ViSession Instrument_Handle, ViReal64 Current_Source)
        /// 
        /// Purpose
        /// 
        /// The NI&#160;4050 and NI&#160;4060 are not supported. Configures the Current_Source for diode measurements.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Current_Source">
        /// 
        /// 
        /// 
        /// 
        /// Current_Source
        /// ViReal64
        /// Specifies the Current_Source provided during diode measurements. For valid ranges on the NI&#160;4065, NI&#160;4070, 4071, or 4072, refer to the 
        /// NI&#160;4065, 
        /// NI&#160;4070, 
        /// NI&#160;4071, or 
        /// NI&#160;4072 topics. The driver sets 
        ///  
        /// NIDMM_ATTR_CURRENT_SOURCE to this value. 
        /// 
        /// 
        /// 
        /// NIDMM_VAL_1_MICROAMP1 &#181;ANI 4070/4071/4072 only
        /// NIDMM_VAL_10_MICROAMP10 &#181;ANI 4070/4071/4072 only
        /// NIDMM_VAL_100_MICROAMP100 &#181;ANI 4070/4071/4072 and NI 4065
        /// NIDMM_VAL_1_MILLIAMP (default)1 mANI 4070/4071/4072 and NI 4065
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureCurrentSource(double Current_Source)
        {
            int pInvokeResult = PInvoke.ConfigureCurrentSource(this._handle, Current_Source);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureWaveformCoupling
        /// 
        /// ViStatus = niDMM_ConfigureWaveformCoupling(ViSession Instrument_Handle, ViInt32 Waveform_Coupling)
        /// 
        /// Purpose
        /// 
        /// For the NI&#160;4070/4071/4072 only, configures instrument coupling for voltage waveforms.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Waveform_Coupling">
        /// 
        /// 
        /// 
        /// 
        /// Waveform_Coupling
        /// ViInt32
        /// Selects DC or AC coupling. The driver sets 
        ///  
        /// NIDMM_ATTR_WAVEFORM_COUPLING to this value.
        /// 
        /// 
        /// 
        /// NameValueDescriptionNIDMM_VAL_WAVEFORM_COUPLING_AC
        /// 0   
        /// AC coupling
        /// NIDMM_VAL_WAVEFORM_COUPLING_DC (default)  
        /// 1
        /// DC coupling
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureWaveformCoupling(int Waveform_Coupling)
        {
            int pInvokeResult = PInvoke.ConfigureWaveformCoupling(this._handle, Waveform_Coupling);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureTrigger
        /// 
        /// ViStatus = niDMM_ConfigureTrigger(ViSession Instrument_Handle, ViInt32 Trigger_Source, ViReal64 Trigger_Delay)
        /// 
        /// Purpose
        /// 
        /// Configures the DMM Trigger_Source and Trigger_Delay. Refer to 
        /// Triggering 
        /// 
        /// and
        ///  
        /// Using Switches for more information.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Trigger_Source">
        /// 
        /// 
        /// 
        /// 
        /// Trigger_Source
        /// ViInt32
        /// Specifies the Trigger_Source that initiates the acquisition. The driver sets 
        ///  
        /// NIDMM_ATTR_TRIGGER_SOURCE to this value. Software configures the DMM to wait until 
        ///  
        /// niDMM_SendSoftwareTrigger is called before triggering the DMM.
        ///  
        /// 
        /// Note&#160;&#160;To determine which values are supported by each device, refer to the 
        /// LabWindows/CVI Trigger Routing section.
        /// 
        /// </param>
        /// <param name="Trigger_Delay">
        /// 
        /// 
        /// 
        /// 
        /// Trigger_Delay
        /// ViReal64
        /// Specifies the time that the DMM waits after it has received a trigger before taking a measurement. The driver sets the 
        /// NIDMM_ATTR_TRIGGER_DELAY attribute to this value. By default, Trigger_Delay is NIDMM_VAL_AUTO_DELAY (-1), which means the DMM waits an appropriate settling time before taking the measurement. On the NI&#160;4060, if you set Trigger_Delay to 0, the DMM does not settle before taking the measurement. The NI&#160;4065 and NI&#160;4070/4071/4072 use the value specified in Trigger_Delay as additional settling time.
        /// 
        /// Note&#160;&#160;When using the NI&#160;4050, Trigger_Delay must be set to NIDMM_VAL_AUTO_DELAY (-1).
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureTrigger(int Trigger_Source, double Trigger_Delay)
        {
            int pInvokeResult = PInvoke.ConfigureTrigger(this._handle, Trigger_Source, Trigger_Delay);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_SendSoftwareTrigger
        /// 
        /// ViStatus = niDMM_SendSoftwareTrigger(ViSession Instrument_Handle)
        /// 
        /// Purpose
        /// 
        /// Sends a command to trigger the DMM. Call this function if you have configured either the 
        ///  
        /// NIDMM_ATTR_TRIGGER_SOURCE or 
        ///  
        /// NIDMM_ATTR_SAMPLE_TRIGGER attributes. If the 
        ///  
        /// NIDMM_ATTR_TRIGGER_SOURCE and/or 
        ///  
        /// NIDMM_ATTR_SAMPLE_TRIGGER attributes are set to NIDMM_VAL_EXTERNAL or NIDMM_VAL_TTLn, you can use this function to override the trigger source that you configured and trigger the NI&#160;4065 and NI&#160;4070/4071/4072.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int SendSoftwareTrigger()
        {
            int pInvokeResult = PInvoke.SendSoftwareTrigger(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureMeasCompleteDest
        /// 
        /// ViStatus = niDMM_ConfigureMeasCompleteDest(ViSession Instrument_Handle, ViInt32 Meas_Complete_Destination)
        /// 
        /// Purpose
        /// 
        /// Specifies the destination of the DMM Measurement Complete (MC) signal. Refer to  Triggering for more information.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Meas_Complete_Destination">
        /// 
        /// 
        /// 
        /// 
        /// Meas_Complete_Destination
        /// ViInt32
        /// Specifies the destination of the Measurement Complete signal. This signal is issued when the DMM completes a single measurement. The driver sets the  NIDMM_ATTR_MEAS_COMPLETE_DEST
        ///  attribute to this value. This signal is commonly referred to as Voltmeter Complete.
        /// 
        /// Note&#160;&#160;To determine which values are supported by each device, refer to the LabWindows/CVI Trigger Routing section.
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureMeasCompleteDest(int Meas_Complete_Destination)
        {
            int pInvokeResult = PInvoke.ConfigureMeasCompleteDest(this._handle, Meas_Complete_Destination);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureTriggerSlope
        /// 
        /// ViStatus = niDMM_ConfigureTriggerSlope(ViSession Instrument_Handle, ViInt32 Trigger_Slope)
        /// 
        /// Purpose
        /// 
        /// Sets the  NIDMM_ATTR_TRIGGER_SLOPE attribute to either rising edge (positive) or falling edge (negative) polarity.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Trigger_Slope">
        /// 
        /// 
        /// 
        /// 
        /// Trigger_Slope
        /// ViInt32
        /// Specifies the polarity of the trigger signal on which the measurement is triggered for values of either NIDMM_VAL_POSITIVE or NIDMM_VAL_NEGATIVE. The driver sets the  NIDMM_ATTR_TRIGGER_SLOPE attribute to this value. 
        /// 
        /// 
        /// 
        /// NIDMM_VAL_POSITIVE
        /// 0
        /// The driver triggers on the rising edge of the trigger signal.
        /// NIDMM_VAL_NEGATIVE&#160;(default)
        /// 1
        /// The driver triggers on the falling edge of the trigger signal.
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureTriggerSlope(int Trigger_Slope)
        {
            int pInvokeResult = PInvoke.ConfigureTriggerSlope(this._handle, Trigger_Slope);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureSampleTriggerSlope
        /// 
        /// ViStatus = niDMM_ConfigureSampleTriggerSlope(ViSession Instrument_Handle, ViInt32 Sample_Trigger_Slope)
        /// 
        /// Purpose
        /// 
        /// Sets the  NIDMM_ATTR_SAMPLE_TRIGGER_SLOPE to either rising edge (positive) or falling edge (negative) polarity.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Sample_Trigger_Slope">
        /// 
        /// 
        /// 
        /// 
        /// Sample_Trigger_Slope
        /// ViInt32
        /// Specifies the polarity of the Trigger signal on which the measurement is triggered for values of either NIDMM_VAL_POSITIVE or NIDMM_VAL_NEGATIVE. The driver sets  NIDMM_ATTR_SAMPLE_TRIGGER_SLOPE to this value. 
        /// 
        /// 
        /// 
        /// 
        /// Rising Edge
        /// 0
        /// NIDMM_VAL_POSITIVE
        /// The driver triggers on the rising edge of the trigger signal.
        /// Falling Edge (default)
        /// 1
        /// NIDMM_VAL_NEGATIVE
        /// The driver triggers on the falling edge of the trigger signal.
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureSampleTriggerSlope(int Sample_Trigger_Slope)
        {
            int pInvokeResult = PInvoke.ConfigureSampleTriggerSlope(this._handle, Sample_Trigger_Slope);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ConfigureMeasCompleteSlope
        /// 
        /// ViStatus = niDMM_ConfigureMeasCompleteSlope(ViSession Instrument_Handle, ViInt32 Meas_Complete_Slope)
        /// 
        /// Purpose
        /// 
        /// Sets the Measurement Complete signal to either rising edge (positive) or falling edge (negative) polarity.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Meas_Complete_Slope">
        /// 
        /// 
        /// 
        /// 
        /// Meas_Complete_Slope
        /// ViInt32
        /// Specifies the polarity of the signal that is generated. The driver sets  NIDMM_ATTR_MEAS_DEST_SLOPE to this value. 
        /// 
        /// 
        /// 
        /// Rising Edge
        /// 0
        /// NIDMM_VAL_POSITIVE
        /// The driver triggers on the rising edge of the trigger signal.
        /// Falling Edge (default)
        /// 1
        /// NIDMM_VAL_NEGATIVE
        /// The driver triggers on the falling edge of the trigger signal.
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ConfigureMeasCompleteSlope(int Meas_Complete_Slope)
        {
            int pInvokeResult = PInvoke.ConfigureMeasCompleteSlope(this._handle, Meas_Complete_Slope);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_GetAutoRangeValue
        /// 
        /// ViStatus = niDMM_GetAutoRangeValue(ViSession Instrument_Handle, ViReal64 *Actual_Range)
        /// 
        /// Purpose
        /// 
        /// Returns the Actual_Range that the DMM is using, even when Auto Range is off.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Actual_Range">
        /// 
        /// 
        /// 
        /// 
        /// Actual_Range
        /// ViReal64*
        /// Indicates the Actual_Range the DMM is using. Returns the value of the  NIDMM_ATTR_AUTO_RANGE_VALUE attribute. The units of the returned value depend on the function. 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int GetAutoRangeValue(out double Actual_Range)
        {
            int pInvokeResult = PInvoke.GetAutoRangeValue(this._handle, out Actual_Range);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_GetApertureTimeInfo
        /// 
        /// ViStatus = niDMM_GetApertureTimeInfo(ViSession Instrument_Handle, ViReal64 *Aperture_Time, ViInt32 *Aperture_Time_Units)
        /// 
        /// Purpose
        /// 
        /// Returns the DMM Aperture_Time and Aperture_Time_Units.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Aperture_Time">
        /// 
        /// 
        /// 
        /// 
        /// Aperture_Time
        /// ViReal64*
        /// Specifies the amount of time the DMM digitizes the input signal for a single measurement. This parameter does not include settling time. Returns the value of the  NIDMM_ATTR_APERTURE_TIME attribute. The units of this attribute depend on the value of the  NIDMM_ATTR_APERTURE_TIME_UNITS attribute. 
        /// 
        /// 
        /// 
        /// On the NI&#160;4070/4071/4072, the minimum aperture time is 8.89 &#181;s, and the maximum aperture time is 149&#160;s. Any number of powerline cycles (PLCs) within the minimum and maximum ranges is allowed on the NI&#160;4070/4071/4072.
        /// 
        /// 
        /// On the NI&#160;4065 the minimum aperture time is 333 &#181;s, and the maximum aperture time is 78.2 s. If setting the number of averages directly, the total measurement time is aperture time X the number of averages, which must be less than 72.8 s. The aperture times allowed are 333 &#181;s, 667 &#181;s, or multiples of 1.11 ms - for example 1.11 ms, 2.22 ms, 3.33 ms, and so on. If you set an aperture time other than 333 &#181;s, 667 &#181;s, or multiples of 1.11 ms, the value will be coerced up to the next supported aperture time.
        /// 
        /// 
        /// 
        /// On the NI&#160;4060, when the powerline frequency is 60, the PLCs allowed are 1&#160;PLC, 6&#160;PLC, 12&#160;PLC, and 120&#160;PLC. When the powerline frequency is 50, the PLCs allowed are 1&#160;PLC, 5&#160;PLC, 10&#160;PLC, and 100&#160;PLC.
        /// 
        /// </param>
        /// <param name="Aperture_Time_Units">
        /// 
        /// 
        /// 
        /// 
        /// Aperture_Time_Units
        /// ViInt32*
        /// Indicates the units of aperture time as powerline cycles (PLCs) or seconds. Returns the value of the  NIDMM_ATTR_APERTURE_TIME_UNITS attribute. 
        /// 
        /// 
        /// 
        /// NIDMM_VAL_SECONDS
        /// 0 
        /// Seconds
        /// NIDMM_VAL_POWER_LINE_CYCLES
        /// 1   
        /// Powerline Cycles
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int GetApertureTimeInfo(out double Aperture_Time, out int Aperture_Time_Units)
        {
            int pInvokeResult = PInvoke.GetApertureTimeInfo(this._handle, out Aperture_Time, out Aperture_Time_Units);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_GetMeasurementPeriod
        /// 
        /// ViStatus = niDMM_GetMeasurementPeriod(ViSession Instrument_Handle, ViReal64 *Period)
        /// 
        /// Purpose
        /// 
        /// Returns the measurement Period, which is the amount of time it takes to complete one measurement with the current configuration. Use this function right before you begin acquiring data&#8212;after you have completely configured the measurement and after all configuration functions have been called.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Period">
        /// 
        /// 
        /// 
        /// 
        /// Period
        /// ViReal64*
        /// Returns the number of seconds it takes to make one measurement. 
        /// 
        /// The first measurement in a multipoint acquisition requires additional settling time. This function does not include this additional time or any  NIDMM_ATTR_TRIGGER_DELAY associated with the first measurement. Time required for internal measurements, such as  NIDMM_ATTR_AUTO_ZERO, is included.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int GetMeasurementPeriod(out double Period)
        {
            int pInvokeResult = PInvoke.GetMeasurementPeriod(this._handle, out Period);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_Read
        /// 
        /// ViStatus = niDMM_Read(ViSession Instrument_Handle, ViInt32 Maximum_Time, ViReal64 *Reading)
        /// 
        /// Purpose
        /// 
        /// Acquires a single measurement and returns the measured value.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Maximum_Time">
        /// 
        /// 
        /// 
        /// 
        /// Maximum_Time
        /// ViInt32
        /// Specifies the Maximum_Time allowed for this function to complete in milliseconds. If the function does not complete within this time interval, the function returns the NIDMM_ERROR_MAX_TIME_EXCEEDED error code. This may happen if an external trigger has not been received, or if the specified timeout is not long enough for the acquisition to complete.The valid range is 0&#8211;86400000. The default value is NIDMM_VAL_TIME_LIMIT_AUTO (-1). The DMM calculates the timeout automatically.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Reading">
        /// 
        /// 
        /// 
        /// 
        /// Reading
        /// ViReal64*
        /// The measured value returned from the DMM.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int Read(int Maximum_Time, out double Reading)
        {
            int pInvokeResult = PInvoke.Read(this._handle, Maximum_Time, out Reading);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ReadMultiPoint
        /// 
        /// ViStatus = niDMM_ReadMultiPoint(ViSession Instrument_Handle, ViInt32 Maximum_Time, ViInt32 Array_Size, ViReal64 Reading_Array[], ViInt32 *Actual_Number_Of_Points)
        /// 
        /// Purpose
        /// 
        /// Acquires multiple measurements and returns an array of measured values. The number of measurements the DMM makes is determined by the values you specify for the Trigger_Count and Sample_Count parameters in  niDMM_ConfigureMultiPoint.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Maximum_Time">
        /// 
        /// 
        /// 
        /// 
        /// Maximum_Time
        /// ViInt32
        /// Specifies the Maximum_Time allowed for this function to complete in milliseconds. If the function does not complete within this time interval, the function returns the NIDMM_ERROR_MAX_TIME_EXCEEDED error code. This may happen if an external trigger has not been received, or if the specified timeout is not long enough for the acquisition to complete.The valid range is 0&#8211;86400000. The default value is NIDMM_VAL_TIME_LIMIT_AUTO (-1). The DMM calculates the timeout automatically.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Array_Size">
        /// 
        /// 
        /// 
        /// 
        /// Array_Size
        /// ViInt32
        /// Specifies the number of measurements to acquire. The maximum number of measurements for a finite acquisition is the (Trigger Count x Sample Count) parameters in  niDMM_ConfigureMultiPoint. For continuous acquisitions, up to 100,000 points can be returned at once. The number of measurements can be a subset.  The valid range is any positive ViInt32. The default value is 1.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Reading_Array">
        /// 
        /// 
        /// 
        /// 
        /// Reading_Array
        /// ViReal64[]
        /// An array of measurement values.
        /// 
        /// 
        /// Note &#160;&#160;The size of the Reading_Array must be at least the size that you specify for the Array_Size parameter.
        /// 
        /// 
        /// </param>
        /// <param name="Actual_Number_Of_Points">
        /// 
        /// 
        /// 
        /// 
        /// Actual_Number_Of_Points
        /// ViInt32*
        /// Indicates the number of measured values actually retrieved from the DMM.
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ReadMultiPoint(int Maximum_Time, int Array_Size, double[] Reading_Array, out int Actual_Number_Of_Points)
        {
            int pInvokeResult = PInvoke.ReadMultiPoint(this._handle, Maximum_Time, Array_Size, Reading_Array, out Actual_Number_Of_Points);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ReadWaveform
        /// 
        /// ViStatus = niDMM_ReadWaveform(ViSession Instrument_Handle, ViInt32 Maximum_Time, ViInt32 Array_Size, ViReal64 Waveform_Array[], ViInt32 *Actual_Number_Of_Points)
        /// 
        /// Purpose
        /// 
        /// For the NI&#160;4070/4071/4072 only, acquires a waveform and returns data as an array of values or as a waveform data type. The number of elements in the Waveform_Array is determined by the values you specify for the Waveform_Points parameter in  niDMM_ConfigureWaveformAcquisition.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Maximum_Time">
        /// 
        /// 
        /// 
        /// 
        /// Maximum_Time
        /// ViInt32
        /// Specifies the Maximum_Time allowed for this function to complete in milliseconds. If the function does not complete within this time interval, the function returns the NIDMM_ERROR_MAX_TIME_EXCEEDED error code. This may happen if an external trigger has not been received, or if the specified timeout is not long enough for the acquisition to complete.The valid range is 0&#8211;86400000. The default value is NIDMM_VAL_TIME_LIMIT_AUTO (-1). The DMM calculates the timeout automatically.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Array_Size">
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Array_Size
        /// ViInt32
        /// Specifies the number of waveform points to return. You specify the total number of points that the DMM acquires in the Waveform Points parameter of  niDMM_ConfigureWaveformAcquisition. The default value is 1.
        /// 
        /// </param>
        /// <param name="Waveform_Array">
        /// 
        /// 
        /// 
        /// Waveform_Array
        /// ViReal64[]
        /// An array of measurement values. 
        /// 
        /// Note &#160;&#160;The size of the Waveform_Array must be at least the size that you specify for the Array_Size parameter.
        /// 
        /// 
        /// </param>
        /// <param name="Actual_Number_Of_Points">
        /// 
        /// 
        /// 
        /// 
        /// Actual_Number_Of_Points
        /// ViInt32*
        /// Indicates the number of measured values actually retrieved from the DMM.
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ReadWaveform(int Maximum_Time, int Array_Size, double[] Waveform_Array, out int Actual_Number_Of_Points)
        {
            int pInvokeResult = PInvoke.ReadWaveform(this._handle, Maximum_Time, Array_Size, Waveform_Array, out Actual_Number_Of_Points);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_IsOverRange
        /// 
        /// ViStatus = niDMM_IsOverRange(ViSession Instrument_Handle, ViReal64 Measurement_Value, ViBoolean *Is_Over_Range)
        /// 
        /// Purpose
        /// 
        /// Takes a Measurement_Value and determines if the value is a valid measurement or a value indicating that an overrange condition occurred.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Measurement_Value">
        /// 
        /// 
        /// 
        /// Measurement_Value
        /// ViReal64
        /// The measured value returned from the DMM. 
        /// 
        /// Note &#160;&#160;If an overrange condition occurs, the Measurement_Value contains an IEEE-defined NaN (Not a Number) value.
        /// 
        /// </param>
        /// <param name="Is_Over_Range">
        /// 
        /// 
        /// 
        /// 
        /// Is_Over_Range
        /// ViBoolean*
        /// Returns whether the measurement value is a valid measurement or an overrange condition. 
        /// 
        /// 
        /// 
        /// VI_TRUE
        /// 1
        /// The value indicates that an overrange condition occurred.
        /// VI_FALSE
        /// 0
        /// The value is a valid measurement.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int IsOverRange(double Measurement_Value, out bool Is_Over_Range)
        {
            ushort Is_Over_RangeAsUShort;
            int pInvokeResult = PInvoke.IsOverRange(this._handle, Measurement_Value, out Is_Over_RangeAsUShort);
            Is_Over_Range = System.Convert.ToBoolean(Is_Over_RangeAsUShort);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_IsUnderRange
        /// 
        /// ViStatus = niDMM_IsUnderRange(ViSession Instrument_Handle, ViReal64 Measurement_Value, ViBoolean *Is_Under_Range)
        /// 
        /// Purpose
        /// 
        /// Takes a Measurement_Value and determines if the value is a valid measurement or a value indicating that an underrange condition occurred.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Measurement_Value">
        /// 
        /// 
        /// 
        /// Measurement_Value
        /// ViReal64
        /// The measured value returned from the DMM. 
        /// 
        /// Note &#160;&#160;If an overrange condition occurs, the Measurement_Value contains an IEEE-defined NaN (Not a Number) value.
        /// 
        /// </param>
        /// <param name="Is_Under_Range">
        /// 
        /// 
        /// 
        /// 
        /// Is_Under_Range
        /// ViBoolean*
        /// Returns whether the Measurement_Value is a valid measurement or an underrange condition. 
        /// 
        /// 
        /// 
        /// VI_TRUE
        /// 1
        /// The value indicates that an underrange condition occurred.
        /// VI_FALSE
        /// 0
        /// The value is a valid measurement.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int IsUnderRange(double Measurement_Value, out bool Is_Under_Range)
        {
            ushort Is_Under_RangeAsUShort;
            int pInvokeResult = PInvoke.IsUnderRange(this._handle, Measurement_Value, out Is_Under_RangeAsUShort);
            Is_Under_Range = System.Convert.ToBoolean(Is_Under_RangeAsUShort);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_Initiate
        /// 
        /// ViStatus = niDMM_Initiate(ViSession Instrument_Handle)
        /// 
        /// Purpose
        /// 
        /// Initiates an acquisition. After you call this function, the DMM leaves the Idle state and enters the Wait-for-Trigger state. If trigger is set to Immediate mode, the DMM begins acquiring measurement data. Use 
        ///  
        /// niDMM_Fetch, 
        ///  
        /// niDMM_FetchMultiPoint, or 
        ///  
        /// niDMM_FetchWaveform to retrieve the measurement data. 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int Initiate()
        {
            int pInvokeResult = PInvoke.Initiate(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_Fetch
        /// 
        /// niDMM_Fetch(ViSession Instrument_Handle, ViInt32 Maximum_Time, ViReal64 *Reading)
        /// 
        /// Purpose
        /// 
        /// Returns the value from a previously initiated measurement. You must call 
        ///  
        /// niDMM_Initiate before calling this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Maximum_Time">
        /// 
        /// 
        /// 
        /// 
        /// Maximum_Time
        /// ViInt32
        /// Specifies the Maximum_Time allowed for this function to complete in milliseconds. If the function does not complete within this time interval, the function returns the NIDMM_ERROR_MAX_TIME_EXCEEDED error code. This may happen if an external trigger has not been received, or if the specified timeout is not long enough for the acquisition to complete.The valid range is 0&#8211;86400000. The default value is NIDMM_VAL_TIME_LIMIT_AUTO (-1). The DMM calculates the timeout automatically.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Reading">
        /// 
        /// 
        /// 
        /// 
        /// Reading
        /// ViReal64*
        /// The measured value returned from the DMM.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int Fetch(int Maximum_Time, out double Reading)
        {
            int pInvokeResult = PInvoke.Fetch(this._handle, Maximum_Time, out Reading);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_FetchMultiPoint
        /// 
        /// ViStatus = niDMM_FetchMultiPoint(ViSession Instrument_Handle, ViInt32 Maximum_Time, ViInt32 Array_Size, ViReal64 Reading_Array[], ViInt32 *Actual_Number_Of_Points)
        /// 
        /// Purpose
        /// 
        /// Returns an array of values from a previously initiated multipoint measurement. The number of measurements the DMM makes is determined by the values you specify for the Trigger_Count and Sample_Count parameters of 
        ///  
        /// niDMM_ConfigureMultiPoint. You must first call 
        ///  
        /// niDMM_Initiate to initiate a measurement before calling this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Maximum_Time">
        /// 
        /// 
        /// 
        /// 
        /// Maximum_Time
        /// ViInt32
        /// Specifies the Maximum_Time allowed for this function to complete in milliseconds. If the function does not complete within this time interval, the function returns the NIDMM_ERROR_MAX_TIME_EXCEEDED error code. This may happen if an external trigger has not been received, or if the specified timeout is not long enough for the acquisition to complete.The valid range is 0&#8211;86400000. The default value is NIDMM_VAL_TIME_LIMIT_AUTO (-1). The DMM calculates the timeout automatically.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Array_Size">
        /// 
        /// 
        /// 
        /// 
        /// Array_Size
        /// ViInt32
        /// Specifies the number of measurements to acquire. The maximum number of measurements for a finite acquisition is the (Trigger Count x Sample Count) parameters in  niDMM_ConfigureMultiPoint. For continuous acquisitions, up to 100,000 points can be returned at once. The number of measurements can be a subset.  The valid range is any positive ViInt32. The default value is 1.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Reading_Array">
        /// 
        /// 
        /// 
        /// 
        /// Reading_Array
        /// ViReal64[]
        /// An array of measurement values.
        /// 
        /// 
        /// Note &#160;&#160;The size of the Reading_Array must be at least the size that you specify for the Array_Size parameter.
        /// 
        /// 
        /// </param>
        /// <param name="Actual_Number_Of_Points">
        /// 
        /// 
        /// 
        /// 
        /// Actual_Number_Of_Points
        /// ViInt32*
        /// Indicates the number of measured values actually retrieved from the DMM.
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int FetchMultiPoint(int Maximum_Time, int Array_Size, double[] Reading_Array, out int Actual_Number_Of_Points)
        {
            int pInvokeResult = PInvoke.FetchMultiPoint(this._handle, Maximum_Time, Array_Size, Reading_Array, out Actual_Number_Of_Points);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_FetchWaveform
        /// 
        /// ViStatus = niDMM_FetchWaveform(ViSession Instrument_Handle, ViInt32 Maximum_Time, ViInt32 Array_Size, ViReal64 Waveform_Array[], ViInt32 *Actual_Number_Of_Points)
        /// 
        /// Purpose
        /// 
        /// For the NI&#160;4070/4071/4072 only, returns an array of values from a previously initiated waveform acquisition. You must call  niDMM_Initiate before calling this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Maximum_Time">
        /// 
        /// 
        /// 
        /// 
        /// Maximum_Time
        /// ViInt32
        /// Specifies the Maximum_Time allowed for this function to complete in milliseconds. If the function does not complete within this time interval, the function returns the NIDMM_ERROR_MAX_TIME_EXCEEDED error code. This may happen if an external trigger has not been received, or if the specified timeout is not long enough for the acquisition to complete.The valid range is 0&#8211;86400000. The default value is NIDMM_VAL_TIME_LIMIT_AUTO (-1). The DMM calculates the timeout automatically.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Array_Size">
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Array_Size
        /// ViInt32
        /// Specifies the number of waveform points to return. You specify the total number of points that the DMM acquires in the Waveform Points parameter of  niDMM_ConfigureWaveformAcquisition. The default value is 1.
        /// 
        /// </param>
        /// <param name="Waveform_Array">
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Waveform_Array
        /// ViReal64 []
        /// Waveform Array is an array of measurement values stored in waveform data type.
        /// 
        /// </param>
        /// <param name="Actual_Number_Of_Points">
        /// 
        /// 
        /// 
        /// 
        /// Actual_Number_Of_Points
        /// ViInt32*
        /// Indicates the number of measured values actually retrieved from the DMM.
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int FetchWaveform(int Maximum_Time, int Array_Size, double[] Waveform_Array, out int Actual_Number_Of_Points)
        {
            int pInvokeResult = PInvoke.FetchWaveform(this._handle, Maximum_Time, Array_Size, Waveform_Array, out Actual_Number_Of_Points);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_Abort
        /// 
        /// ViStatus = niDMM_Abort(ViSession Instrument_Handle)
        /// 
        /// Purpose
        /// 
        /// Aborts a previously initiated measurement and returns the DMM to the Idle state.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int Abort()
        {
            int pInvokeResult = PInvoke.Abort(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ReadStatus
        /// 
        /// ViStatus = niDMM_ReadStatus(ViSession Instrument_Handle, ViInt32 *Acquisition_Backlog, ViInt16 *Acquisition_Status)
        /// 
        /// Purpose
        /// 
        /// Returns measurement backlog and acquisition status. Use this function to determine how many measurements are available before calling  niDMM_Fetch,  niDMM_FetchMultipoint, or  niDMM_FetchWaveform.
        /// 
        /// Note&#160;&#160;The NI&#160;4050 is not supported.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Acquisition_Backlog">
        /// 
        /// 
        /// 
        /// 
        /// Acquisition_Backlog
        /// ViInt32*
        /// The number of measurements available to be read. If the backlog continues to increase, data is eventually overwritten, resulting in an error. 
        /// Note&#160;&#160;On the NI 4060, the Backlog does not increase 
        /// when autoranging. On the NI 4065, the Backlog
        ///  does not increase when Range is set to AUTO RANGE ON (-1), or before the first point is fetched when Range is set to AUTO RANGE ONCE (-3). These behaviors are due to the autorange model of the devices. 
        ///  
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Acquisition_Status">
        /// 
        /// 
        /// 
        /// 
        /// Acquisition_Status
        /// ViInt16*
        /// Indicates status of the acquisition. The following table shows the acquisition states:
        /// 
        /// 
        /// 
        /// 0
        /// Running
        /// 1
        /// Finished with backlog
        /// 2
        /// Finished with no backlog
        /// 3
        /// Paused
        /// 4
        /// No acquisition in progress
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ReadStatus(out int Acquisition_Backlog, out short Acquisition_Status)
        {
            int pInvokeResult = PInvoke.ReadStatus(this._handle, out Acquisition_Backlog, out Acquisition_Status);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_Control
        /// 
        /// ViStatus = niDMM_Control(ViSession Instrument_Handle, ViInt32 Control_Action)
        /// 
        /// Purpose
        /// 
        /// Controls the DMM. Use this function if you want a parameter change to be 
        /// immediately reflected in the hardware.  Use this function before calling  niDMM_Initiate 
        /// to make the initiate call as quickly as possible.
        /// 
        /// 
        /// Notes&#160;&#160;The NI 4050 and NI 4060 are not supported.
        /// 
        /// 
        /// Calling this function  while the DMM is taking measurements   results in an error.  After the DMM is finished 
        /// taking measurements, calling this function  will make any unfetched data points unavailable.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Control_Action">
        /// 
        /// 
        /// 
        /// Control Action
        /// ViInt32
        /// The action you want the driver to perform. Only  NIDMM_VAL_CONTROL_COMMIT (0) is supported, which commits to hardware all of the 
        /// configured attributes associated with the session.  
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int Control(int Control_Action)
        {
            int pInvokeResult = PInvoke.Control(this._handle, Control_Action);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_SelfCal
        /// 
        /// ViStatus = niDMM_SelfCal(ViSession Instrument_Handle)
        /// 
        /// Purpose
        /// 
        /// For the NI 4070/4071/4072 only, executes the self-calibration routine to maintain measurement accuracy. 
        /// 
        /// 
        /// Note&#160;&#160;This function calls  niDMM_reset, and any configurations previous to the call will be lost.  All attributes will be set to their default values after the call returns.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int SelfCal()
        {
            int pInvokeResult = PInvoke.SelfCal(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_CalAdjustLinearization
        /// 
        /// ViStatus = niDMM_CalAdjustLinearization(ViSession Instrument_Handle, ViInt32 Mode, ViReal64 Range, ViReal64 Input_Resistance, ViReal64 Expected_Value)
        /// 
        /// Purpose
        /// 
        /// For the NI 4065 only, compensates for any non-linearities.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// The session handle that you  obtain from  niDMM_InitExtCal. The handle identifies a particular instrument calibration session.
        /// 
        ///
        /// 
        /// 
        /// </param>
        /// <param name="Function">
        /// 
        /// 
        /// 
        /// 
        /// Function
        /// ViInt32
        /// Specifies the calibration Function used to acquire the measurement.For valid modes, refer to the NI&#160;4065 6&#189; Digit DMM Calibration Procedure.
        /// 
        /// </param>
        /// <param name="Range">
        /// 
        /// 
        /// 
        /// 
        /// Range
        /// ViReal64
        /// Specifies the Range to calibrate. 
        /// Range values are coerced up to the closest Range.For valid ranges, refer to the NI&#160;4065 6&#189; Digit DMM Calibration Procedure. Auto-ranging is not supported for calibration operations.
        /// 
        /// 
        /// </param>
        /// <param name="Input_Resistance">
        /// 
        /// 
        /// 
        /// 
        /// Input_Resistance
        /// ViReal64
        /// Specifies the Input_Resistance that the device should use. Input_Resistance values are coerced up to the closest Input_Resistance. 
        /// 
        /// </param>
        /// <param name="Expected_Value">
        /// 
        /// 
        /// 
        /// 
        /// Expected_Value
        /// ViReal64
        /// Specifies the Expected_Value of the measurement. 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int CalAdjustLinearization(int Function, double Range, double Input_Resistance, double Expected_Value)
        {
            int pInvokeResult = PInvoke.CalAdjustLinearization(this._handle, Function, Range, Input_Resistance, Expected_Value);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_CalAdjustGain
        /// 
        /// ViStatus = niDMM_CalAdjustGain(ViSession Instrument_Handle, ViInt32 Mode, ViReal64 Range, ViReal64 Input_Resistance, ViReal64 Expected_Value)
        /// 
        /// Purpose
        /// 
        /// Calibrates the gain coefficient for the supplied Mode, Range, and Input_Resistance.
        /// 
        /// Notes&#160;&#160;The NI&#160;4050 and NI&#160;4060 are not supported.
        /// 
        /// Refer to the NI&#160;4065 6&#189; Digit DMM Calibration Procedure, the NI&#160;4070/4072 6&#189; Digit FlexDMM Calibration Procedure, or the NI&#160;4071 7&#189;&#8211;Digit FlexDMM Calibration Procedure before using this function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// The session handle that you obtain from  niDMM_InitExtCal. The handle identifies a particular instrument calibration session.
        /// 
        ///
        /// 
        /// 
        /// </param>
        /// <param name="Mode">
        /// 
        /// 
        /// 
        /// 
        /// Mode
        /// ViInt32
        /// Specifies the calibration Mode used to acquire the measurement. 
        /// For valid modes, refer to the NI&#160;4065 6&#189; Digit DMM Calibration Procedure, the NI&#160;4070/4072 6&#189; Digit FlexDMM Calibration Procedure, or the NI&#160;4071 7&#189;&#8211;Digit FlexDMM Calibration Procedure.
        /// 
        /// 
        /// </param>
        /// <param name="Range">
        /// 
        /// 
        /// 
        /// Range
        /// ViReal64
        /// Specifies the Range to calibrate. 
        /// For valid ranges, refer to the NI&#160;4065 6&#189; Digit DMM Calibration Procedure, the NI&#160;4070/4072 6&#189; Digit FlexDMM Calibration Procedure, or the NI&#160;4071 7&#189;&#8211;Digit FlexDMM Calibration Procedure. Auto-ranging is not supported for calibration operations.
        /// 
        /// </param>
        /// <param name="Input_Resistance">
        /// 
        /// 
        /// 
        /// 
        /// Input_Resistance
        /// ViReal64
        /// Specifies the Input_Resistance that the device should use. Input_Resistance values are coerced up to the closest Input_Resistance. 
        /// 
        /// </param>
        /// <param name="Expected_Value">
        /// 
        /// 
        /// 
        /// 
        /// Expected_Value
        /// ViReal64
        /// Specifies the Expected_Value of the measurement. 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int CalAdjustGain(int Mode, double Range, double Input_Resistance, double Expected_Value)
        {
            int pInvokeResult = PInvoke.CalAdjustGain(this._handle, Mode, Range, Input_Resistance, Expected_Value);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_CalAdjustOffset
        /// 
        /// ViStatus = niDMM_CalAdjustOffset(ViSession Instrument_Handle, ViInt32 Mode, ViReal64 Range, ViReal64 Input_Resistance)
        /// 
        /// Purpose
        /// 
        /// Calibrates the offset and Auto Zero offset for the supplied Mode, Range, and Input_Resistance.
        /// 
        /// Note&#160;&#160;The NI&#160;4050 and NI&#160;4060 are not supported.
        /// 
        /// Refer to the NI&#160;4065 6&#189; Digit DMM Calibration Procedure, the NI&#160;4070/4072 6&#189; Digit FlexDMM Calibration Procedure, or the NI&#160;4071 7&#189;&#8211;Digit FlexDMM Calibration Procedure before using this function.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// The session handle that you obtain from  niDMM_InitExtCal. The handle identifies a particular instrument calibration session.
        /// 
        ///
        /// 
        /// 
        /// </param>
        /// <param name="Mode">
        /// 
        /// 
        /// 
        /// 
        /// Mode
        /// ViInt32
        /// Specifies the calibration Mode used to acquire the measurement. 
        /// For valid modes, refer to the NI&#160;4065 6&#189; Digit DMM Calibration Procedure, the NI&#160;4070/4072 6&#189; Digit FlexDMM Calibration Procedure, or the NI&#160;4071 7&#189;&#8211;Digit FlexDMM Calibration Procedure.
        /// 
        /// 
        /// </param>
        /// <param name="Range">
        /// 
        /// 
        /// 
        /// Range
        /// ViReal64
        /// Specifies the Range to calibrate. 
        /// For valid ranges, refer to the NI&#160;4065 6&#189; Digit DMM Calibration Procedure, the NI&#160;4070/4072 6&#189; Digit FlexDMM Calibration Procedure, or the NI&#160;4071 7&#189;&#8211;Digit FlexDMM Calibration Procedure. Auto-ranging is not supported for calibration operations.
        /// 
        /// </param>
        /// <param name="Input_Resistance">
        /// 
        /// 
        /// 
        /// 
        /// Input_Resistance
        /// ViReal64
        /// Specifies the Input_Resistance that the device should use. Input_Resistance values are coerced up to the closest Input_Resistance. 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int CalAdjustOffset(int Mode, double Range, double Input_Resistance)
        {
            int pInvokeResult = PInvoke.CalAdjustOffset(this._handle, Mode, Range, Input_Resistance);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_CalAdjustMisc
        /// 
        /// ViStatus = niDMM_CalAdjustMisc(ViSession Instrument_Handle, ViInt32 Type)
        /// 
        /// Purpose
        /// 
        /// Performs a specialized calibration step depending on the specified Type.
        /// 
        /// Note&#160;&#160;The NI&#160;4050 and NI&#160;4060 are not supported.
        /// 
        /// Refer to the NI&#160;4065 6&#189; Digit DMM Calibration Procedure, the NI&#160;4070/4072 6&#189; Digit FlexDMM Calibration Procedure, or the NI&#160;4071 7&#189;&#8211;Digit FlexDMM Calibration Procedure before using this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// The session handle that you obtain from  niDMM_InitExtCal. The handle identifies a particular instrument calibration session.
        /// 
        ///
        /// 
        /// 
        /// </param>
        /// <param name="Type">
        /// 
        /// 
        /// 
        /// 
        /// Type
        /// ViInt32
        /// Specifies which of the miscellaneous calibration steps to perform.
        /// 
        /// 
        /// 
        /// NIDMM_EXTCAL_MISCCAL_VREF (default)
        /// Calibrate the Voltage Reference.
        /// NIDMM_EXTCAL_MISCCAL_RREF
        /// Calibrate the Resistance Reference.
        /// NIDMM_EXTCAL_MISCCAL_ZINT
        /// Calibrate the Internal Impedance.
        /// NIDMM_EXTCAL_MISCCAL_2WIRELEAKAGE
        /// Calibrate the 2-wire Leakage resistance.
        /// NIDMM_EXTCAL_MISCCAL_4WIRELEAKAGE
        /// Calibrate the 4-wire Leakage resistance.
        /// NIDMM_EXTCAL_MISCCAL_SECTION
        /// Update calibration information and verify calibration completeness. 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int CalAdjustMisc(int Type)
        {
            int pInvokeResult = PInvoke.CalAdjustMisc(this._handle, Type);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_CalAdjustLC
        /// 
        /// ViStatus = niDMM_CalAdjustLC(ViSession Instrument_Handle, ViInt32 Type)
        /// 
        /// Purpose
        /// 
        /// For the NI&#160;4072 only, performs a specialized LC calibration step depending on the specified Type.
        /// 
        /// Note&#160;&#160;Refer to the NI&#160;4070/4072 6&#189; Digit FlexDMM Calibration Procedure before using this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// The session handle that you obtain from  niDMM_InitExtCal. The handle identifies a particular instrument calibration session.
        /// 
        ///
        /// 
        /// 
        /// </param>
        /// <param name="Type">
        /// 
        /// 
        /// 
        /// 
        /// Type
        /// ViInt32
        /// Specifies which of the LC calibration steps to perform.
        /// 
        /// 
        /// 
        /// L &amp; C Open (default)
        /// Calibrates the open compensation.
        /// L &amp; C Short
        /// Calibrates the short compensation.
        /// L &amp; C 25 &#937;;
        /// Calibrates the 25 &#937;; resistance.
        /// L &amp; C 1 k&#937;;
        /// Calibrates the 1 k&#937;; resistance.
        /// L &amp; C 5 k&#937;;
        /// Calibrates the 5 k&#937;; resistance.
        /// L &amp; C 100 k&#937;;
        /// Calibrates the 100 k&#937;; resistance.  
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int CalAdjustLC(int Type)
        {
            int pInvokeResult = PInvoke.CalAdjustLC(this._handle, Type);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_CalAdjustACFilter
        /// 
        /// ViStatus = niDMM_CalAdjustACFilter(ViSession Instrument_Handle, ViInt32 Mode, ViReal64 Range, ViReal64 Frequency, ViReal64 Expected_Value)
        /// 
        /// Purpose
        /// 
        /// For the NI&#160;4070/4071/4072 only, calibrates the filter coefficients used for AC measurements of the supplied Mode and Range.
        /// 
        /// Note&#160;&#160;Refer to the NI&#160;4070/4072 6&#189; Digit FlexDMM Calibration Procedure or the NI&#160;4071 7&#189;&#8211;Digit FlexDMM Calibration Procedure before using this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// The session handle that you obtain from  niDMM_InitExtCal. The handle identifies a particular instrument calibration session.
        /// 
        ///
        /// 
        /// 
        /// </param>
        /// <param name="Mode">
        /// 
        /// 
        /// 
        /// 
        /// Mode
        /// ViInt32
        /// Specifies the calibration Mode used to acquire the measurement. 
        /// For valid modes, refer to the NI&#160;4065 6&#189; Digit DMM Calibration Procedure, the NI&#160;4070/4072 6&#189; Digit FlexDMM Calibration Procedure, or the NI&#160;4071 7&#189;&#8211;Digit FlexDMM Calibration Procedure.
        /// 
        /// 
        /// </param>
        /// <param name="Range">
        /// 
        /// 
        /// 
        /// 
        /// Range
        /// ViReal64
        /// Specifies the Range to calibrate. 
        /// For valid ranges, refer to the NI&#160;4070/4072 6&#189; Digit FlexDMM Calibration Procedure or the NI&#160;4071 7&#189;&#8211;Digit FlexDMM Calibration Procedure. Auto-ranging is not supported for calibration operations.
        /// 
        /// </param>
        /// <param name="Frequency">
        /// 
        /// 
        /// 
        /// 
        /// Frequency
        /// ViReal64
        /// Specifies the Frequency of the input signal. 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Expected_Value">
        /// 
        /// 
        /// 
        /// 
        /// Expected_Value
        /// ViReal64
        /// Specifies the Expected_Value of the measurement. 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int CalAdjustACFilter(int Mode, double Range, double Frequency, double Expected_Value)
        {
            int pInvokeResult = PInvoke.CalAdjustACFilter(this._handle, Mode, Range, Frequency, Expected_Value);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_CloseExtCal
        /// 
        /// ViStatus = niDMM_CloseExtCal(ViSession Instrument_Handle, ViInt32 Action)
        /// 
        /// Purpose
        /// 
        /// Performs the specified Action, closes the specified external calibration session obtained from  niDMM_InitExtCal, and deallocates resources that it reserved.
        /// 
        /// Note&#160;&#160;The NI&#160;4050 and NI&#160;4060 are not supported.
        /// 
        /// Refer to the NI&#160;4065 6&#189; Digit DMM Calibration Procedure, the NI&#160;4070/4072 6&#189; Digit FlexDMM Calibration Procedure, or the NI&#160;4071 7&#189;&#8211;Digit FlexDMM Calibration Procedure before using this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// html>
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// The session handle that you obtain from  niDMM_InitExtCal. The handle identifies a particular instrument calibration session.
        /// 
        /// 
        ///
        /// 
        /// 
        /// </param>
        /// <param name="Action">
        /// 
        /// 
        /// 
        /// Action
        /// ViInt32
        /// Specifies whether the driver saves the updated calibration constants.
        /// 
        /// 
        /// 
        /// NIDMM_EXTCAL_ACTION_ABORT&#160;(default)
        /// Restores the calibration constants to what they were before starting the external calibration procedure.
        /// NIDMM_EXTCAL_ACTION_SAVE
        /// Saves the new calibration constants to the device. 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int CloseExtCal(int Action)
        {
            int pInvokeResult = PInvoke.CloseExtCal(this._handle, Action);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_GetCalCount
        /// 
        /// ViStatus = niDMM_GetCalCount(ViSession Instrument_Handle, ViInt32 Cal_Type, ViInt32 *Count)
        /// 
        /// Purpose
        /// 
        /// Returns the calibration Count for the specified type of calibration.
        /// Note&#160;&#160;The NI&#160;4050 and NI&#160;4060 are not supported.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Cal_Type">
        /// 
        /// 
        /// 
        /// 
        /// Cal_Type
        /// ViInt32
        /// Specifies the type of calibration performed (external or self-calibration).
        /// 
        /// 
        /// 
        /// NIDMM_VAL_INTERNAL_AREA&#160;(default)
        /// Note&#160;&#160;The NI&#160;4065 does not support self-calibration.
        /// 0
        /// Self-Calibration
        /// NIDMM_VAL_EXTERNAL_AREA
        /// 1
        /// External Calibration
        /// 
        /// </param>
        /// <param name="Count">
        /// 
        /// 
        /// 
        /// 
        /// Count
        /// ViInt32*
        /// The number of times calibration has been performed.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int GetCalCount(int Cal_Type, out int Count)
        {
            int pInvokeResult = PInvoke.GetCalCount(this._handle, Cal_Type, out Count);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_GetCalDateAndTime
        /// 
        /// ViStatus = niDMM_GetCalDateAndTime(ViSession Instrument_Handle, ViInt32 Cal_Type, ViInt32 *Month, ViInt32 *Day, ViInt32 *Year, ViInt32 *Hour, ViInt32 *Minute)
        /// 
        /// Purpose
        /// 
        /// Returns the date and time of the last calibration performed.
        /// Note&#160;&#160;The NI&#160;4050 and NI&#160;4060 are not supported.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Cal_Type">
        /// 
        /// 
        /// 
        /// 
        /// Cal_Type
        /// ViInt32
        /// Specifies the type of calibration performed (external or self-calibration).
        /// 
        /// 
        /// 
        /// NIDMM_VAL_INTERNAL_AREA&#160;(default)
        /// Note&#160;&#160;The NI&#160;4065 does not support self-calibration.
        /// 0
        /// Self-Calibration
        /// NIDMM_VAL_EXTERNAL_AREA
        /// 1
        /// External Calibration
        /// 
        /// </param>
        /// <param name="Month">
        /// 
        /// 
        /// 
        /// 
        /// Month
        /// ViInt32*
        /// Indicates the Month of the last calibration. 
        /// 
        /// </param>
        /// <param name="Day">
        /// 
        /// 
        /// 
        /// 
        /// Day
        /// ViInt32*
        /// Indicates the Day of the last calibration.
        /// 
        /// </param>
        /// <param name="Year">
        /// 
        /// 
        /// 
        /// 
        /// Year
        /// ViInt32*
        /// Indicates the Year of the last calibration. 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Hour">
        /// 
        /// 
        /// 
        /// 
        /// Hour
        /// ViInt32*
        /// Indicates the Hour of the last calibration.  
        /// 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Minute">
        /// 
        /// 
        /// 
        /// 
        /// Minute
        /// ViInt32*
        /// Indicates the Minute of the last calibration.   
        /// 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int GetCalDateAndTime(int Cal_Type, out int Month, out int Day, out int Year, out int Hour, out int Minute)
        {
            int pInvokeResult = PInvoke.GetCalDateAndTime(this._handle, Cal_Type, out Month, out Day, out Year, out Hour, out Minute);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_GetDevTemp
        /// 
        /// ViStatus = niDMM_GetDevTemp(ViSession Instrument_Handle, ViString Options, ViReal64 *Temperature)
        /// 
        /// Purpose
        /// 
        ///  Returns the current Temperature of the device.
        /// Note&#160;&#160;The NI&#160;4050 and NI&#160;4060 are not supported.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Options">
        /// 
        /// 
        /// 
        /// 
        /// Options
        /// ViString
        /// Reserved.
        /// 
        /// </param>
        /// <param name="Temperature">
        /// 
        /// 
        /// 
        /// 
        /// Temperature
        /// ViReal64*
        /// Returns the current Temperature of the device.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int GetDevTemp(string Options, out double Temperature)
        {
            int pInvokeResult = PInvoke.GetDevTemp(this._handle, Options, out Temperature);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_GetLastCalTemp
        /// 
        /// ViStatus = niDMM_GetLastCalTemp(ViSession Instrument_Handle, ViInt32 Cal_Type, ViReal64 *Temperature)
        /// 
        /// Purpose
        /// 
        /// Returns the Temperature during the last calibration procedure.
        /// Note&#160;&#160;The NI&#160;4050 and NI&#160;4060 are not supported.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Cal_Type">
        /// 
        /// 
        /// 
        /// 
        /// Cal_Type
        /// ViInt32
        /// Specifies the type of calibration performed (external or self-calibration).
        /// 
        /// 
        /// 
        /// NIDMM_VAL_INTERNAL_AREA&#160;(default)
        /// Note&#160;&#160;The NI&#160;4065 does not support self-calibration.
        /// 0
        /// Self-Calibration
        /// NIDMM_VAL_EXTERNAL_AREA
        /// 1
        /// External Calibration
        /// 
        /// </param>
        /// <param name="Temperature">
        /// 
        /// 
        /// 
        /// 
        /// Temperature
        /// ViReal64*
        /// Returns the Temperature during the last calibration. 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int GetLastCalTemp(int Cal_Type, out double Temperature)
        {
            int pInvokeResult = PInvoke.GetLastCalTemp(this._handle, Cal_Type, out Temperature);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_GetCalUserDefinedInfoMaxSize
        /// 
        /// ViStatus = niDMM_GetCalUserDefinedInfoMaxSize(ViSession Instrument_Handle, ViInt32 *Info_Size)
        /// 
        /// Purpose
        /// 
        /// Returns the maximum string length that can be stored in the EEPROM. Use 
        ///  niDMM_SetCalUserDefinedInfo
        ///  to store user-defined information.
        /// Note&#160;&#160;The NI&#160;4050 and NI&#160;4060 are not supported.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Info_Size">
        /// 
        /// 
        /// 
        /// 
        /// Info_Size
        /// ViInt32*
        /// Returns the value of maximum string length that can be stored in the EEPROM using 
        ///  niDMM_SetCalUserDefinedInfo. The Info_Size value is given in characters, but it does not include the termination character.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int GetCalUserDefinedInfoMaxSize(out int Info_Size)
        {
            int pInvokeResult = PInvoke.GetCalUserDefinedInfoMaxSize(this._handle, out Info_Size);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_GetCalUserDefinedInfo
        /// 
        /// ViStatus = niDMM_GetCalUserDefinedInfo(ViSession Instrument_Handle, ViInt32 Buffer_Size, ViChar Info[])
        /// 
        /// Purpose
        /// 
        /// Returns the user-defined calibration information stored in the EEPROM.
        /// Note&#160;&#160;The NI&#160;4050 and NI&#160;4060 are not supported.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Buffer_Size">
        /// 
        /// 
        /// 
        /// 
        /// Buffer_Size
        /// ViInt32
        /// Passes the number of bytes in the ViString you specify for the Info parameter. 
        /// If zero is passed for this parameter, the Buffer_Size needed to store the information is returned. If the Info parameter, including the terminating NULL byte, contains more bytes than you indicate in this parameter, the function copies Buffer_Size - 1 bytes into the buffer, places an ASCII NULL byte at the end of the buffer, and returns the Buffer_Size you must pass to get the entire value.
        /// 
        /// For example, if the value is &quot;123456&quot; and the Buffer_Size is 4, the function places &quot;123&quot; into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
        /// 
        /// 
        /// </param>
        /// <param name="Info">
        /// 
        /// 
        /// 
        /// 
        /// Info
        /// ViChar[]
        /// Returns the user-defined calibration information stored in the EEPROM. If this is NULL, the Buffer_Size needed to store the information is returned.
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int GetCalUserDefinedInfo(int Buffer_Size, System.Text.StringBuilder Info)
        {
            int pInvokeResult = PInvoke.GetCalUserDefinedInfo(this._handle, Buffer_Size, Info);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_SetCalUserDefinedInfo
        /// 
        /// ViStatus = niDMM_SetCalUserDefinedInfo(ViSession Instrument_Handle, ViChar Info[])
        /// 
        /// Purpose
        /// 
        /// Stores the user-defined information in the EEPROM. Use  niDMM_GetCalUserDefinedInfoMaxSize to learn the maximum string size that is allowed. If the Info string size is larger than the maximum string size, NI-DMM stores as much of the information as possible, truncates the remainder, and returns a warning.
        /// Note&#160;&#160;The NI&#160;4050 and NI&#160;4060 are not supported.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Info">
        /// 
        /// 
        /// 
        /// 
        /// Info
        /// ViChar[]
        /// Specifies the user-defined information to be stored in the EEPROM such as the operator who performed the calibration operation or system information. Use  niDMM_GetCalUserDefinedInfoMaxSize to learn the maximum string size that is allowed. If the Info string size is larger than the maximum string size, NI-DMM stores as much of the information as possible, truncates the remainder, and return a warning.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int SetCalUserDefinedInfo(string Info)
        {
            int pInvokeResult = PInvoke.SetCalUserDefinedInfo(this._handle, Info);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_GetExtCalRecommendedInterval
        /// 
        /// ViStatus = niDMM_GetExtCalRecommendedInterval(ViSession Instrument_Handle, ViInt32 *Months)
        /// 
        /// Purpose
        /// 
        /// Returns the recommended interval between external recalibration in Months.
        /// Note&#160;&#160;The NI&#160;4050 and NI&#160;4060 are not supported.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Months">
        /// 
        /// 
        /// 
        /// 
        /// Months
        /// ViInt32*
        /// Returns the recommended number of Months between external calibrations.
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int GetExtCalRecommendedInterval(out int Months)
        {
            int pInvokeResult = PInvoke.GetExtCalRecommendedInterval(this._handle, out Months);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_GetSelfCalSupported
        /// 
        /// ViStatus = niDMM_GetSelfCalSupported(ViSession Instrument_Handle, ViBoolean *Self_Cal_Supported)
        /// 
        /// Purpose
        /// 
        /// Returns a Boolean value that expresses whether or not the DMM that you are using can perform self-calibration.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Self_Cal_Supported">
        /// 
        /// 
        /// 
        /// 
        /// Self_Cal_Supported
        /// ViBoolean*
        /// Returns whether Self Cal is supported for the device specified by the given session.
        /// 
        /// 
        /// VI_TRUE 
        /// 1
        /// The DMM that you are using can perform self-calibration.
        /// VI_FALSE
        /// 0
        /// The DMM that you are using cannot perform self-calibration.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int GetSelfCalSupported(out bool Self_Cal_Supported)
        {
            ushort Self_Cal_SupportedAsUShort;
            int pInvokeResult = PInvoke.GetSelfCalSupported(this._handle, out Self_Cal_SupportedAsUShort);
            Self_Cal_Supported = System.Convert.ToBoolean(Self_Cal_SupportedAsUShort);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_RestoreLastExtCalConstants
        /// 
        /// ViStatus = niDMM_RestoreLastExtCalConstants(ViSession Instrument_Handle)
        /// 
        /// Purpose
        /// 
        /// Reverts the device to the calibration constants from the last complete external calibration. This function recovers the hardware if a fatal system error should occur during an external or self-calibration procedure.
        /// 
        /// For the NI 4070/4071/4072 only, after calling this function, you should call  niDMM_SelfCal before taking measurements with the device to adjust the device for any temperature drifts since the last external calibration.
        /// Note&#160;&#160;The NI&#160;4050 and NI&#160;4060 are not supported.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int RestoreLastExtCalConstants()
        {
            int pInvokeResult = PInvoke.RestoreLastExtCalConstants(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_SetCalPassword
        /// 
        /// ViStatus = niDMM_SetCalPassword(ViSession Instrument_Handle, ViChar Old_Password[], ViChar New_Password[])
        /// 
        /// Purpose
        /// 
        /// Changes the password required to enable external calibration functionality for the specified instrument. The maximum password string length is eight characters, excluding the termination character. &quot;NI&quot; is the default password.
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Notes&#160;&#160;
        /// 
        /// The NI&#160;4050 and NI&#160;4060 are not supported.
        /// 
        /// A password is required for external calibration. Be sure to record the password in a secure location.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Old_Password">
        /// 
        /// 
        /// 
        /// 
        /// Old_Password
        /// ViChar[]
        /// Specifies the current password required to enable external calibration functionality. The maximum password string length is eight characters, excluding the termination character.
        /// 
        /// </param>
        /// <param name="New_Password">
        /// 
        /// 
        /// 
        /// 
        /// New_Password
        /// ViChar[]
        /// Specifies the New_Password required to enable external calibration functionality. The maximum password string length is eight characters, excluding the termination character.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int SetCalPassword(string Old_Password, string New_Password)
        {
            int pInvokeResult = PInvoke.SetCalPassword(this._handle, Old_Password, New_Password);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_reset
        /// 
        /// ViStatus = niDMM_reset(ViSession Instrument_Handle)
        /// 
        /// Purpose
        /// 
        /// Resets the instrument to a known state and sends initialization commands to the instrument. The initialization commands set instrument settings to the state necessary for the operation of the instrument driver.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int reset()
        {
            int pInvokeResult = PInvoke.reset(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ResetWithDefaults
        /// 
        /// ViStatus = niDMM_ResetWithDefaults(ViSession Instrument_Handle)
        /// 
        /// Purpose
        /// 
        /// Resets the instrument to a known state and sends initialization commands to the DMM. The initialization commands set the DMM settings to the state necessary for the operation of NI-DMM. All user-defined default values associated with a logical name are applied after setting the DMM.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ResetWithDefaults()
        {
            int pInvokeResult = PInvoke.ResetWithDefaults(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_self_test
        /// 
        /// ViStatus = niDMM_self_test(ViSession Instrument_Handle, ViInt16 *Self_Test_Result, ViChar Self_-_Test_Message[])
        /// 
        /// Purpose
        /// 
        /// Performs a self-test on the DMM to ensure that the DMM is functioning properly. Self-test does not calibrate the DMM.
        /// 
        /// 
        /// Note&#160;&#160;This function calls  niDMM_reset, and any configurations previous to the call will be lost.  All attributes will be set to their default values after the call returns.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Self_Test_Result">
        /// 
        /// 
        /// 
        /// 
        /// Self_Test_Result
        /// ViInt16*
        /// Contains the value returned from the instrument self-test. Zero indicates success. 
        /// 
        /// On the NI&#160;4070/4072, the error code 1013 indicates that you should check the fuse and replace it, if necessary.
        /// 
        /// 
        /// Note&#160;&#160;Self-test does not check the fuse on the NI&#160;4065 and NI&#160;4071. Hence, even if the fuse is blown on the NI&#160;4065 or NI&#160;4071, self-test does not return error code 1013.
        /// 
        /// 
        /// </param>
        /// <param name="Self___Test_Message">
        /// 
        /// 
        /// 
        /// 
        /// Self_-_Test_Message
        /// ViChar[ ]
        /// This parameter contains the string returned from the instrument self-test. The array must contain at least 256 elements. 
        /// For the NI&#160;4050 and NI&#160;4060, the error codes returned for self-test failures include the following:
        /// NIDMM_ERROR_AC_TEST_FAILURE
        /// NIDMM_ERROR_DC_TEST_FAILURE
        /// NIDMM_ERROR_RESISTANCE_TEST_FAILURE
        /// These error codes indicate that the DMM should be repaired.
        /// 
        /// For the NI&#160;4070/4071/4072, the error code returned for a self-test failure is NIDMM_ERROR_SELF_TEST_FAILURE. This error code indicates that the DMM should be repaired.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int self_test(out short Self_Test_Result, System.Text.StringBuilder Self___Test_Message)
        {
            int pInvokeResult = PInvoke.self_test(this._handle, out Self_Test_Result, Self___Test_Message);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_revision_query
        /// 
        /// ViStatus = niDMM_revision_query(ViSession Instrument_Handle, ViChar Instrument_Driver_Revision[], ViChar Firmware_Revision[])
        /// 
        /// Purpose
        /// 
        /// Returns the revision numbers of the instrument driver and instrument firmware.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Instrument_Driver_Revision">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Driver_Revision
        /// ViChar[]
        /// Returns a string containing the instrument driver software revision numbers.
        /// 
        /// 
        /// Note &#160;&#160;The array must contain at least 256 elements ViChar[256]. 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Firmware_Revision">
        /// 
        /// 
        /// 
        /// 
        /// Firmware_Revision
        /// ViChar[]
        /// Returns a string containing the instrument Firmware_Revision numbers. 
        /// 
        /// 
        /// Note &#160;&#160;The array must contain at least 256 elements ViChar[256]. 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int revision_query(System.Text.StringBuilder Instrument_Driver_Revision, System.Text.StringBuilder Firmware_Revision)
        {
            int pInvokeResult = PInvoke.revision_query(this._handle, Instrument_Driver_Revision, Firmware_Revision);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_Disable
        /// 
        /// ViStatus = niDMM_Disable(ViSession Instrument_Handle)
        /// 
        /// Purpose
        /// 
        /// Places the instrument in a quiescent state where it has minimal or no impact on the system to which it is connected. If a measurement is in progress when this function is called, the measurement is aborted.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int Disable()
        {
            int pInvokeResult = PInvoke.Disable(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_GetChannelName
        /// 
        /// ViStatus = niDMM_GetChannelName(ViSession Instrument_Handle, ViInt32 Index, ViInt32 Buffer_Size, ViChar Channel_String[])
        /// 
        /// Purpose
        /// 
        /// Returns the Channel_String that is in the channel table at an Index you specify. Not applicable to National Instruments DMMs. Included for compliance with the IviDmm Class Specification.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Index">
        /// 
        /// 
        /// 
        /// 
        /// Index
        /// ViInt32
        /// A 1&#8211;based Index into the channel table.
        /// 
        /// </param>
        /// <param name="Buffer_Size">
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Buffer_Size
        /// 
        /// ViInt32
        /// 
        /// Passes the number of bytes in the ViChar array you specify for the Channel_String parameter. If the next Channel_String, including the terminating NULL byte, contains more bytes than you indicate in this parameter, the function copies Buffer_Size&#160;&#8211;1&#160;bytes into the buffer, places an ASCII NULL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value.
        /// For example, if the value is &quot;123456&quot; and the Buffer_Size is 4, the function places &quot;123&quot; into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. If you pass 0, you can pass VI_NULL for the Channel_String buffer parameter. The default value is None.
        /// 
        /// 
        /// </param>
        /// <param name="Channel_String">
        /// 
        /// 
        /// 
        /// 
        /// Channel_String
        /// ViChar[ ]
        /// Returns the Channel_String that is in the channel table at the Index you specify. Do not modify the contents of the Channel_String. 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int GetChannelName(int Index, int Buffer_Size, System.Text.StringBuilder Channel_String)
        {
            int pInvokeResult = PInvoke.GetChannelName(this._handle, Index, Buffer_Size, Channel_String);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_error_query
        /// 
        /// ViStatus = niDMM_error_query(ViSession Instrument_Handle, ViStatus *Error_Code, ViChar Error_Message[])
        /// 
        /// Purpose
        /// 
        /// Reads an Error_Code and message from the DMM error queue. National Instruments DMMs do not contain an error queue. Errors are reported as they occur. Therefore, this function does not detect errors; it is included for compliance with the IviDmm Class Specification.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Error_Code">
        /// 
        /// 
        /// 
        /// 
        /// Error_Code
        /// ViStatus*
        /// The Error_Code returned from the instrument. 
        /// 
        /// The default value is VI_SUCCESS (0).
        /// 
        /// </param>
        /// <param name="Error_Message">
        /// 
        /// 
        /// 
        /// Error_Message
        /// ViChar[]
        /// Formats the Error_Code into a user-readable message string. 
        /// 
        /// 
        /// Note &#160;&#160;The array must contain at least 256 elements ViChar[256].
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int error_query(out int Error_Code, System.Text.StringBuilder Error_Message)
        {
            int pInvokeResult = PInvoke.error_query(this._handle, out Error_Code, Error_Message);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_GetNextInterchangeWarning
        /// 
        /// ViStatus = niDMM_GetNextInterchangeWarning(ViSession Instrument_Handle, ViInt32 Buffer_Size, ViChar Interchange_Warning[])
        /// 
        /// Purpose
        /// 
        /// This function returns the interchangeability warnings associated with the IVI session. It retrieves and clears the oldest instance in which the class driver recorded an interchangeability warning. Interchangeability warnings indicate that using your application with a different instrument might cause different behavior. 
        /// The driver performs interchangeability checking when  NIDMM_ATTR_INTERCHANGE_CHECK is set to VI_TRUE (1). The function returns an empty string in the Interchange_Warning parameter if no interchangeability warnings remain for the session. In general, the instrument driver generates interchangeability warnings when an attribute that affects the behavior of the instrument is in a state that you did not specify.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Buffer_Size">
        /// 
        /// 
        /// 
        /// 
        /// Buffer_Size
        /// ViInt32
        /// Passes the number of bytes in the ViChar array you specify for the Interchange_Warning parameter. If the next interchangeability warning string, including the terminating NULL byte, contains more bytes than you indicate in this parameter, the function copies Buffer_Size&#160;&#8211;1&#160;bytes into the buffer, places an ASCII NULL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. 
        /// 
        /// For example, if the value is &quot;123456&quot; and the Buffer_Size is 4, the function places &quot;123&quot; into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. If you pass 0, you can pass VI_NULL for the Interchange_Warning buffer parameter. The default value is None.
        /// 
        /// </param>
        /// <param name="Interchange_Warning">
        /// 
        /// 
        /// 
        /// 
        /// Interchange_Warning
        /// ViChar[]
        /// Returns the next interchange warning for the IVI session. If there are no interchange warnings, the function returns an empty string. The buffer must contain at least as many elements as the value you specify with the Buffer_Size parameter. 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int GetNextInterchangeWarning(int Buffer_Size, System.Text.StringBuilder Interchange_Warning)
        {
            int pInvokeResult = PInvoke.GetNextInterchangeWarning(this._handle, Buffer_Size, Interchange_Warning);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ClearInterchangeWarnings
        /// 
        /// ViStatus = niDMM_ClearInterchangeWarnings(ViSession Instrument_Handle)
        /// 
        /// Purpose
        /// 
        /// Clears the list of current interchange warnings.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ClearInterchangeWarnings()
        {
            int pInvokeResult = PInvoke.ClearInterchangeWarnings(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_ResetInterchangeCheck
        /// 
        /// ViStatus = niDMM_ResetInterchangeCheck(ViSession Instrument_Handle)
        /// 
        /// Purpose
        /// 
        /// When developing a complex test system that consists of multiple test modules, it is generally a good idea to design the test modules so that they can run in any order. To do so requires ensuring that each test module completely configures the state of each instrument it uses.
        /// 
        /// If a particular test module does not completely configure the state of an instrument, the state of the instrument depends on the configuration from a previously executed test module. If you execute the test modules in a different order, the behavior of the instrument and therefore the entire test module is likely to change. This change in behavior is generally instrument specific and represents an interchangeability problem. You can use this function to test for such cases. After you call this function, the interchangeability checking algorithms in NI-DMM ignore all previous configuration operations. By calling this function at the beginning of a test module, you can determine whether the test module has dependencies on the operation of previously executed test modules.
        /// 
        /// This function does not clear the interchangeability warnings from the list of previously recorded interchangeability warnings. If you want to guarantee that  niDMM_GetNextInterchangeWarning only returns those interchangeability warnings that are generated after calling this function, you must clear the list of interchangeability warnings. You can clear the interchangeability warnings list by repeatedly calling  niDMM_GetNextInterchangeWarning until no more interchangeability warnings are returned. If you are not interested in the content of those warnings, you can call  niDMM_ClearInterchangeWarnings.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int ResetInterchangeCheck()
        {
            int pInvokeResult = PInvoke.ResetInterchangeCheck(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_GetNextCoercionRecord
        /// 
        /// ViStatus = niDMM_GetNextCoercionRecord(ViSession Instrument_Handle, ViInt32 Buffer_Size, ViChar Coercion_Record[])
        /// 
        /// Purpose
        /// 
        /// This function returns the coercion information associated with the IVI session, and it retrieves and clears the oldest instance in which NI-DMM coerced a value you specified to another value.
        /// 
        /// If you set  NIDMM_ATTR_RECORD_COERCIONS to VI_TRUE (1), NI-DMM keeps a list of all coercions it makes on ViInt32 or ViReal64 values that you pass to NI-DMM functions. Use this function to retrieve information from that list.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        /// 
        /// 
        /// Instrument_Handle
        /// ViSession
        /// Identifies a particular instrument session. You obtain the Instrument_Handle parameter from  niDMM_init or  niDMM_InitWithOptions. The default is None.  
        /// 
        /// 
        /// </param>
        /// <param name="Buffer_Size">
        /// 
        /// 
        /// 
        /// 
        /// Buffer_Size
        /// ViInt32
        /// Passes the number of bytes in the ViChar array you specify for the Coercion_Record parameter. If the next coercion record string, including the terminating NULL byte, contains more bytes than you indicate in this parameter, the function copies Buffer_Size &#8211; 1 bytes into the buffer, places an ASCII NULL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. 
        /// 
        /// For example, if the value is &quot;123456&quot; and the Buffer_Size is 4, the function places &quot;123&quot; into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. 
        /// 
        /// If you pass 0, you can pass VI_NULL for the Coercion_Record buffer parameter.
        /// 
        /// The default value is None.
        /// 
        /// </param>
        /// <param name="Coercion_Record">
        /// 
        /// 
        /// 
        /// 
        /// Coercion_Record
        /// ViChar[]
        /// Returns the next Coercion_Record for the IVI session. 
        /// 
        /// If there are no coercions records, the function returns an empty string. The buffer must contain at least as many elements as the value you specify with the Buffer_Size parameter.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public int GetNextCoercionRecord(int Buffer_Size, System.Text.StringBuilder Coercion_Record)
        {
            int pInvokeResult = PInvoke.GetNextCoercionRecord(this._handle, Buffer_Size, Coercion_Record);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// niDMM_FormatMeasAbsolute
        /// 
        /// ViStatus = niDMM_FormatMeasAbsolute(ViInt32 Measurement_Function, ViReal64 Range, ViReal64 Resolution, ViReal64 Measurement, ViChar Mode_String[], ViChar Range_String[], ViChar Data_String[])
        /// 
        /// Purpose
        /// 
        /// Formats the Measurement to the proper number of displayed digits according to the Measurement_Function, Range, and Resolution. Returns the formatted data, range, and mode strings.
        /// 
        /// </summary>
        /// <param name="Measurement_Function">
        /// 
        /// 
        /// 
        /// 
        /// Measurement_Function
        /// ViInt32
        /// Specifies the Measurement_Function used to acquire the measurement. The driver sets  NIDMM_ATTR_FUNCTION to this value. 
        /// 
        /// 
        /// </param>
        /// <param name="Range">
        /// 
        /// 
        /// 
        /// 
        /// Range
        /// ViReal64
        /// Specifies the  NIDMM_ATTR_RANGE used to acquire the Measurement. 
        /// 
        /// </param>
        /// <param name="Resolution">
        /// 
        /// 
        /// 
        /// 
        /// Resolution
        /// ViReal64
        /// Specifies the  NIDMM_ATTR_RESOLUTION_ABSOLUTE of the Measurement. 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Measurement">
        /// 
        /// 
        /// 
        /// 
        /// Measurement
        /// ViReal64
        /// Specifies the measured value returned from the DMM. 
        /// 
        /// </param>
        /// <param name="Mode_String">
        /// 
        /// 
        /// 
        /// Mode_String
        /// ViChar[]
        /// Returns a string containing the units of the Measurement mode.
        /// 
        /// </param>
        /// <param name="Range_String">
        /// 
        /// 
        /// 
        /// 
        /// Range_String
        /// ViChar[]
        /// Returns the  NIDMM_ATTR_RANGE of the Measurement, formatted into a string with the correct number of display digits.
        /// 
        /// </param>
        /// <param name="Data_String">
        /// 
        /// 
        /// 
        /// 
        /// Data_String
        /// ViChar[]
        /// Returns the Measurement, formatted according to the  NIDMM_ATTR_FUNCTION,  NIDMM_ATTR_RANGE, and  NIDMM_ATTR_RESOLUTION_ABSOLUTE. 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Reports the Status of this operation. To obtain a text description of the status code, call  
        ///  niDMM_error_message. To obtain additional information concerning the error condition, use 
        ///  niDMM_GetError.
        /// 
        /// </returns>
        public static int FormatMeasAbsolute(int Measurement_Function, double Range, double Resolution, double Measurement, System.Text.StringBuilder Mode_String, System.Text.StringBuilder Range_String, System.Text.StringBuilder Data_String)
        {
            int pInvokeResult = PInvoke.FormatMeasAbsolute(Measurement_Function, Range, Resolution, Measurement, Mode_String, Range_String, Data_String);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }

        public void Dispose()
        {
            this.Dispose(true);
            System.GC.SuppressFinalize(this);
        }

        private void Dispose(bool disposing)
        {
            if ((this._disposed == false))
            {
                PInvoke.close(this._handle);
                this._handle = System.IntPtr.Zero;
            }
            this._disposed = true;
        }

        public void SetInt32(nidmmProperties propertyId, string repeatedCapabilityOrChannel, int val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViInt32(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }

        public void SetInt32(nidmmProperties propertyId, int val)
        {
            this.SetInt32(propertyId, "", val);
        }

        public int GetInt32(nidmmProperties propertyId, string repeatedCapabilityOrChannel)
        {
            int val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViInt32(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return val;
        }

        public int GetInt32(nidmmProperties propertyId)
        {
            return this.GetInt32(propertyId, "");
        }

        public void SetDouble(nidmmProperties propertyId, string repeatedCapabilityOrChannel, double val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViReal64(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }

        public void SetDouble(nidmmProperties propertyId, double val)
        {
            this.SetDouble(propertyId, "", val);
        }

        public double GetDouble(nidmmProperties propertyId, string repeatedCapabilityOrChannel)
        {
            double val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViReal64(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return val;
        }

        public double GetDouble(nidmmProperties propertyId)
        {
            return this.GetDouble(propertyId, "");
        }

        public void SetBoolean(nidmmProperties propertyId, string repeatedCapabilityOrChannel, bool val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViBoolean(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), System.Convert.ToUInt16(val)));
        }

        public void SetBoolean(nidmmProperties propertyId, bool val)
        {
            this.SetBoolean(propertyId, "", val);
        }

        public bool GetBoolean(nidmmProperties propertyId, string repeatedCapabilityOrChannel)
        {
            ushort val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViBoolean(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return System.Convert.ToBoolean(val);
        }

        public bool GetBoolean(nidmmProperties propertyId)
        {
            return this.GetBoolean(propertyId, "");
        }

        public void SetString(nidmmProperties propertyId, string repeatedCapabilityOrChannel, string val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViString(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }

        public void SetString(nidmmProperties propertyId, string val)
        {
            this.SetString(propertyId, "", val);
        }

        public string GetString(nidmmProperties propertyId, string repeatedCapabilityOrChannel)
        {
            System.Text.StringBuilder newVal = new System.Text.StringBuilder(512);
            int size = PInvoke.GetAttributeViString(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), 512, newVal);
            if ((size < 0))
            {
                PInvoke.ThrowError(this._handle, size);
            }
            else
            {
                if ((size > 0))
                {
                    newVal.Capacity = size;
                    PInvoke.TestForError(this._handle, PInvoke.GetAttributeViString(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), size, newVal));
                }
            }
            return newVal.ToString();
        }

        public string GetString(nidmmProperties propertyId)
        {
            return this.GetString(propertyId, "");
        }

        private class PInvoke
        {

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_init", CallingConvention = CallingConvention.StdCall)]
            public static extern int init(string Resource_Name, ushort ID__Query, ushort Reset_Device, out System.IntPtr Instrument_Handle);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_InitWithOptions", CallingConvention = CallingConvention.StdCall)]
            public static extern int InitWithOptions(string Resource_Name, ushort ID__Query, ushort Reset_Device, string Option_String, out System.IntPtr Instrument_Handle);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_InitExtCal", CallingConvention = CallingConvention.StdCall)]
            public static extern int InitExtCal(string Resource_Name, string Calibration_Password, out System.IntPtr Instrument_Handle);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureMeasurementDigits", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureMeasurementDigits(System.IntPtr Instrument_Handle, int Measurement_Function, double Range, double Resolution_Digits);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureMeasurementAbsolute", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureMeasurementAbsolute(System.IntPtr Instrument_Handle, int Measurement_Function, double Range, double Resolution_Absolute);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureMultiPoint", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureMultiPoint(System.IntPtr Instrument_Handle, int Trigger_Count, int Sample_Count, int Sample_Trigger, double Sample_Interval);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureWaveformAcquisition", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureWaveformAcquisition(System.IntPtr Instrument_Handle, int Measurement_Function, double Range, double Rate, int Waveform_Points);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureCableCompType", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureCableCompType(System.IntPtr Instrument_Handle, int Cable_Comp_Type);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureOpenCableCompValues", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureOpenCableCompValues(System.IntPtr Instrument_Handle, double Conductance, double Susceptance);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureShortCableCompValues", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureShortCableCompValues(System.IntPtr Instrument_Handle, double Resistance, double Reactance);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_PerformOpenCableComp", CallingConvention = CallingConvention.StdCall)]
            public static extern int PerformOpenCableComp(System.IntPtr Instrument_Handle, out double Conductance, out double Susceptance);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_PerformShortCableComp", CallingConvention = CallingConvention.StdCall)]
            public static extern int PerformShortCableComp(System.IntPtr Instrument_Handle, out double Resistance, out double Reactance);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureTransducerType", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureTransducerType(System.IntPtr Instrument_Handle, int Transducer_Type);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureThermocouple", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureThermocouple(System.IntPtr Instrument_Handle, int Thermocouple_Type, int Reference_Junction_Type);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureFixedRefJunction", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureFixedRefJunction(System.IntPtr Instrument_Handle, double Fixed_Reference_Junction);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureRTDType", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureRTDType(System.IntPtr Instrument_Handle, int RTD_Type, double RTD_Resistance);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureRTDCustom", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureRTDCustom(System.IntPtr Instrument_Handle, double RTD_A, double RTD_B, double RTD_C);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureThermistorType", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureThermistorType(System.IntPtr Instrument_Handle, int Thermistor_Type);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureThermistorCustom", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureThermistorCustom(System.IntPtr Instrument_Handle, double Thermistor_A, double Thermistor_B, double Thermistor_C);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigurePowerLineFrequency", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigurePowerLineFrequency(System.IntPtr Instrument_Handle, double Power_Line_Frequency_Hz);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureAutoZeroMode", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureAutoZeroMode(System.IntPtr Instrument_Handle, int Auto_Zero_Mode);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureADCCalibration", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureADCCalibration(System.IntPtr Instrument_Handle, int ADC__Calibration);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureOffsetCompOhms", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureOffsetCompOhms(System.IntPtr Instrument_Handle, int Offset_Comp_Ohms);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureACBandwidth", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureACBandwidth(System.IntPtr Instrument_Handle, double AC__Minimum_Frequency_Hz, double AC__Maximum_Frequency_Hz);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureFrequencyVoltageRange", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureFrequencyVoltageRange(System.IntPtr Instrument_Handle, double Voltage_Range);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureCurrentSource", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureCurrentSource(System.IntPtr Instrument_Handle, double Current_Source);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureWaveformCoupling", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureWaveformCoupling(System.IntPtr Instrument_Handle, int Waveform_Coupling);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureTrigger", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureTrigger(System.IntPtr Instrument_Handle, int Trigger_Source, double Trigger_Delay);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_SendSoftwareTrigger", CallingConvention = CallingConvention.StdCall)]
            public static extern int SendSoftwareTrigger(System.IntPtr Instrument_Handle);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureMeasCompleteDest", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureMeasCompleteDest(System.IntPtr Instrument_Handle, int Meas_Complete_Destination);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureTriggerSlope", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureTriggerSlope(System.IntPtr Instrument_Handle, int Trigger_Slope);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureSampleTriggerSlope", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureSampleTriggerSlope(System.IntPtr Instrument_Handle, int Sample_Trigger_Slope);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ConfigureMeasCompleteSlope", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureMeasCompleteSlope(System.IntPtr Instrument_Handle, int Meas_Complete_Slope);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetAutoRangeValue", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetAutoRangeValue(System.IntPtr Instrument_Handle, out double Actual_Range);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetApertureTimeInfo", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetApertureTimeInfo(System.IntPtr Instrument_Handle, out double Aperture_Time, out int Aperture_Time_Units);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetMeasurementPeriod", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetMeasurementPeriod(System.IntPtr Instrument_Handle, out double Period);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_Read", CallingConvention = CallingConvention.StdCall)]
            public static extern int Read(System.IntPtr Instrument_Handle, int Maximum_Time, out double Reading);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ReadMultiPoint", CallingConvention = CallingConvention.StdCall)]
            public static extern int ReadMultiPoint(System.IntPtr Instrument_Handle, int Maximum_Time, int Array_Size, [In, Out] double[] Reading_Array, out int Actual_Number_Of_Points);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ReadWaveform", CallingConvention = CallingConvention.StdCall)]
            public static extern int ReadWaveform(System.IntPtr Instrument_Handle, int Maximum_Time, int Array_Size, [In, Out] double[] Waveform_Array, out int Actual_Number_Of_Points);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_IsOverRange", CallingConvention = CallingConvention.StdCall)]
            public static extern int IsOverRange(System.IntPtr Instrument_Handle, double Measurement_Value, out ushort Is_Over_Range);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_IsUnderRange", CallingConvention = CallingConvention.StdCall)]
            public static extern int IsUnderRange(System.IntPtr Instrument_Handle, double Measurement_Value, out ushort Is_Under_Range);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_Initiate", CallingConvention = CallingConvention.StdCall)]
            public static extern int Initiate(System.IntPtr Instrument_Handle);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_Fetch", CallingConvention = CallingConvention.StdCall)]
            public static extern int Fetch(System.IntPtr Instrument_Handle, int Maximum_Time, out double Reading);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_FetchMultiPoint", CallingConvention = CallingConvention.StdCall)]
            public static extern int FetchMultiPoint(System.IntPtr Instrument_Handle, int Maximum_Time, int Array_Size, [In, Out] double[] Reading_Array, out int Actual_Number_Of_Points);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_FetchWaveform", CallingConvention = CallingConvention.StdCall)]
            public static extern int FetchWaveform(System.IntPtr Instrument_Handle, int Maximum_Time, int Array_Size, [In, Out] double[] Waveform_Array, out int Actual_Number_Of_Points);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_Abort", CallingConvention = CallingConvention.StdCall)]
            public static extern int Abort(System.IntPtr Instrument_Handle);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ReadStatus", CallingConvention = CallingConvention.StdCall)]
            public static extern int ReadStatus(System.IntPtr Instrument_Handle, out int Acquisition_Backlog, out short Acquisition_Status);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_Control", CallingConvention = CallingConvention.StdCall)]
            public static extern int Control(System.IntPtr Instrument_Handle, int Control_Action);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_SelfCal", CallingConvention = CallingConvention.StdCall)]
            public static extern int SelfCal(System.IntPtr Instrument_Handle);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_CalAdjustLinearization", CallingConvention = CallingConvention.StdCall)]
            public static extern int CalAdjustLinearization(System.IntPtr Instrument_Handle, int Function, double Range, double Input_Resistance, double Expected_Value);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_CalAdjustGain", CallingConvention = CallingConvention.StdCall)]
            public static extern int CalAdjustGain(System.IntPtr Instrument_Handle, int Mode, double Range, double Input_Resistance, double Expected_Value);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_CalAdjustOffset", CallingConvention = CallingConvention.StdCall)]
            public static extern int CalAdjustOffset(System.IntPtr Instrument_Handle, int Mode, double Range, double Input_Resistance);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_CalAdjustMisc", CallingConvention = CallingConvention.StdCall)]
            public static extern int CalAdjustMisc(System.IntPtr Instrument_Handle, int Type);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_CalAdjustLC", CallingConvention = CallingConvention.StdCall)]
            public static extern int CalAdjustLC(System.IntPtr Instrument_Handle, int Type);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_CalAdjustACFilter", CallingConvention = CallingConvention.StdCall)]
            public static extern int CalAdjustACFilter(System.IntPtr Instrument_Handle, int Mode, double Range, double Frequency, double Expected_Value);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_CloseExtCal", CallingConvention = CallingConvention.StdCall)]
            public static extern int CloseExtCal(System.IntPtr Instrument_Handle, int Action);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetCalCount", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetCalCount(System.IntPtr Instrument_Handle, int Cal_Type, out int Count);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetCalDateAndTime", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetCalDateAndTime(System.IntPtr Instrument_Handle, int Cal_Type, out int Month, out int Day, out int Year, out int Hour, out int Minute);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetDevTemp", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetDevTemp(System.IntPtr Instrument_Handle, string Options, out double Temperature);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetLastCalTemp", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetLastCalTemp(System.IntPtr Instrument_Handle, int Cal_Type, out double Temperature);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetCalUserDefinedInfoMaxSize", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetCalUserDefinedInfoMaxSize(System.IntPtr Instrument_Handle, out int Info_Size);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetCalUserDefinedInfo", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetCalUserDefinedInfo(System.IntPtr Instrument_Handle, int Buffer_Size, System.Text.StringBuilder Info);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_SetCalUserDefinedInfo", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetCalUserDefinedInfo(System.IntPtr Instrument_Handle, string Info);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetExtCalRecommendedInterval", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetExtCalRecommendedInterval(System.IntPtr Instrument_Handle, out int Months);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetSelfCalSupported", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetSelfCalSupported(System.IntPtr Instrument_Handle, out ushort Self_Cal_Supported);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_RestoreLastExtCalConstants", CallingConvention = CallingConvention.StdCall)]
            public static extern int RestoreLastExtCalConstants(System.IntPtr Instrument_Handle);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_SetCalPassword", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetCalPassword(System.IntPtr Instrument_Handle, string Old_Password, string New_Password);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_reset", CallingConvention = CallingConvention.StdCall)]
            public static extern int reset(System.IntPtr Instrument_Handle);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ResetWithDefaults", CallingConvention = CallingConvention.StdCall)]
            public static extern int ResetWithDefaults(System.IntPtr Instrument_Handle);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_self_test", CallingConvention = CallingConvention.StdCall)]
            public static extern int self_test(System.IntPtr Instrument_Handle, out short Self_Test_Result, System.Text.StringBuilder Self___Test_Message);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_revision_query", CallingConvention = CallingConvention.StdCall)]
            public static extern int revision_query(System.IntPtr Instrument_Handle, System.Text.StringBuilder Instrument_Driver_Revision, System.Text.StringBuilder Firmware_Revision);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_Disable", CallingConvention = CallingConvention.StdCall)]
            public static extern int Disable(System.IntPtr Instrument_Handle);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetChannelName", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetChannelName(System.IntPtr Instrument_Handle, int Index, int Buffer_Size, System.Text.StringBuilder Channel_String);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_error_query", CallingConvention = CallingConvention.StdCall)]
            public static extern int error_query(System.IntPtr Instrument_Handle, out int Error_Code, System.Text.StringBuilder Error_Message);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetNextInterchangeWarning", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetNextInterchangeWarning(System.IntPtr Instrument_Handle, int Buffer_Size, System.Text.StringBuilder Interchange_Warning);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ClearInterchangeWarnings", CallingConvention = CallingConvention.StdCall)]
            public static extern int ClearInterchangeWarnings(System.IntPtr Instrument_Handle);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_ResetInterchangeCheck", CallingConvention = CallingConvention.StdCall)]
            public static extern int ResetInterchangeCheck(System.IntPtr Instrument_Handle);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetNextCoercionRecord", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetNextCoercionRecord(System.IntPtr Instrument_Handle, int Buffer_Size, System.Text.StringBuilder Coercion_Record);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_FormatMeasAbsolute", CallingConvention = CallingConvention.StdCall)]
            public static extern int FormatMeasAbsolute(int Measurement_Function, double Range, double Resolution, double Measurement, System.Text.StringBuilder Mode_String, System.Text.StringBuilder Range_String, System.Text.StringBuilder Data_String);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_close", CallingConvention = CallingConvention.StdCall)]
            public static extern int close(System.IntPtr Instrument_Handle);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_error_message", CallingConvention = CallingConvention.StdCall)]
            public static extern int error_message(System.IntPtr Instrument_Handle, int Error_Code, System.Text.StringBuilder Error_Message_2);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetAttributeViBoolean", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetAttributeViBoolean(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out ushort Attribute_Value);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetAttributeViInt32", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetAttributeViInt32(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out int Attribute_Value);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetAttributeViReal64", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetAttributeViReal64(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out double Attribute_Value);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetAttributeViSession", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetAttributeViSession(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out System.IntPtr Attribute_Value);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetAttributeViString", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetAttributeViString(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, int Buffer_Size, System.Text.StringBuilder Attribute_Value);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_SetAttributeViBoolean", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetAttributeViBoolean(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, ushort Attribute_Value);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_SetAttributeViInt32", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetAttributeViInt32(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, int Attribute_Value);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_SetAttributeViReal64", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetAttributeViReal64(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, double Attribute_Value);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_SetAttributeViSession", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetAttributeViSession(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, System.IntPtr Attribute_Value);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_SetAttributeViString", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetAttributeViString(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, string Attribute_Value);

            [DllImport("niDMM_32.dll", EntryPoint = "niDMM_GetError", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetError(System.IntPtr Instrument_Handle, out int Error_Code, int Buffer_Size, System.Text.StringBuilder Description);


            public static int TestForError(System.IntPtr handle, int status)
            {
                if ((status < 0))
                {
                    PInvoke.ThrowError(handle, status);
                }
                return status;
            }

            public static int ThrowError(System.IntPtr handle, int code)
            {
                int status;
                int size = PInvoke.GetError(handle, out status, 0, null);
                System.Text.StringBuilder msg = new System.Text.StringBuilder();
                if ((size >= 0))
                {
                    msg.Capacity = size;
                    PInvoke.GetError(handle, out status, size, msg);
                }
                throw new System.Runtime.InteropServices.ExternalException(msg.ToString(), code);
            }
        }
    }

    public class nidmmConstants
    {

        public const int DcVolts = 1;

        public const int AcVolts = 2;

        public const int DcCurrent = 3;

        public const int AcCurrent = 4;

        public const int _2WireRes = 5;

        public const int _4WireRes = 101;

        public const int Diode = 1002;

        public const int Freq = 104;

        public const int Period = 105;

        public const int AcVoltsDcCoupled = 1001;

        public const int Capacitance = 1005;

        public const int Inductance = 1006;

        public const int Temperature = 108;

        public const int Immediate = 1;

        public const int External = 2;

        public const int SoftwareTrig = 3;

        public const int Interval = 10;

        public const int Ttl0 = 111;

        public const int Ttl1 = 112;

        public const int Ttl2 = 113;

        public const int Ttl3 = 114;

        public const int Ttl4 = 115;

        public const int Ttl5 = 116;

        public const int Ttl6 = 117;

        public const int Ttl7 = 118;

        public const int PxiStar = 131;

        public const int LbrTrig1 = 1004;

        public const int AuxTrig1 = 1001;

        public const int WaveformVoltage = 1003;

        public const int WaveformCurrent = 1004;

        public const int CableCompNone = 0;

        public const int CableCompOpen = 1;

        public const int CableCompShort = 2;

        public const int CableCompOpenAndShort = 3;

        public const int Thermocouple = 1;

        public const int _2WireRtd = 3;

        public const int _4WireRtd = 4;

        public const int Thermistor = 2;

        public const int TempTcB = 1;

        public const int TempTcE = 4;

        public const int TempTcJ = 6;

        public const int TempTcK = 7;

        public const int TempTcN = 8;

        public const int TempTcR = 9;

        public const int TempTcS = 10;

        public const int TempTcT = 11;

        public const int TempRefJuncFixed = 2;

        public const int TempRtdCustom = 0;

        public const int TempRtdPt3750 = 1;

        public const int TempRtdPt3851 = 2;

        public const int TempRtdPt3911 = 3;

        public const int TempRtdPt3916 = 4;

        public const int TempRtdPt3920 = 5;

        public const int TempRtdPt3928 = 6;

        public const int TempThermistorCustom = 0;

        public const int AutoZeroAuto = -1;

        public const int AutoZeroOff = 0;

        public const int AutoZeroOn = 1;

        public const int AutoZeroOnce = 2;

        public const int AdcCalibrationAuto = -1;

        public const int AdcCalibrationOff = 0;

        public const int AdcCalibrationOn = 1;

        public const int OffsetCompOhmsOff = 0;

        public const int OffsetCompOhmsOn = 1;

        public const double _1Milliamp = 0.001;

        public const double _100Microamp = 0.0001;

        public const double _10Microamp = 1E-05;

        public const double _1Microamp = 1E-06;

        public const int WaveformCouplingAc = 0;

        public const int WaveformCouplingDc = 1;

        public const int None = -1;

        public const int Negative = 1;

        public const int Positive = 0;

        public const double ResistanceNa = 0;

        public const double _1Megaohm = 1000000;

        public const double _10Megaohm = 10000000;

        public const double GreaterThan10Gigaohm = 10000000000;

        public const int ExtcalMisccalVref = 0;

        public const int ExtcalMisccalRref = 1;

        public const int ExtcalMisccalZint = 2;

        public const int ExtcalMisccal2wireleakage = 3;

        public const int ExtcalMisccal4wireleakage = 4;

        public const int ExtcalMisccalSection = 5;

        public const int ExtcalLcOpen = 0;

        public const int ExtcalLcShort = 1;

        public const int ExtcalLc25ohm = 2;

        public const int ExtcalLc1kohm = 3;

        public const int ExtcalLc5kohm = 4;

        public const int ExtcalLc100kohm = 5;

        public const int ExtcalActionAbort = 0;

        public const int ExtcalActionSave = 1;

        public const int ExternalArea = 1;

        public const int InternalArea = 0;

        public const int DcnrAuto = -1;

        public const int DcnrNormal = 0;

        public const int DcnrSecondOrder = 1;

        public const int DcnrHighOrder = 2;

        public const double _50Hertz = 50;

        public const double _60Hertz = 60;

        public const int CalcModelAuto = -1;

        public const int CalcModelSeries = 0;

        public const int CalcModelParallel = 1;

        public const int DcBiasOff = 0;

        public const int DcBiasOn = 1;

        public const int ControlCommit = 0;

        public const int LbrTrig0 = 1003;

        public const int Seconds = 0;

        public const int PowerLineCycles = 1;

        public const int IvidmmMode = 0;

        public const int WaveformMode = 1;
    }

    public enum nidmmProperties
    {

        /// <summary>
        /// System.Boolean
        /// </summary>
        Cache = 1050004,

        /// <summary>
        /// System.String
        /// </summary>
        DriverSetup = 1050007,

        /// <summary>
        /// System.Boolean
        /// </summary>
        InterchangeCheck = 1050021,

        /// <summary>
        /// System.Boolean
        /// </summary>
        QueryInstrumentStatus = 1050003,

        /// <summary>
        /// System.Boolean
        /// </summary>
        RangeCheck = 1050002,

        /// <summary>
        /// System.Boolean
        /// </summary>
        RecordCoercions = 1050006,

        /// <summary>
        /// System.Boolean
        /// </summary>
        Simulate = 1050005,

        /// <summary>
        /// System.Int32
        /// </summary>
        ChannelCount = 1050203,

        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverPrefix = 1050302,

        /// <summary>
        /// System.Int32
        /// </summary>
        SpecificDriverMajorVersion = 1050503,

        /// <summary>
        /// System.Int32
        /// </summary>
        SpecificDriverMinorVersion = 1050504,

        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverRevision = 1050551,

        /// <summary>
        /// System.String
        /// </summary>
        IdQueryResponse = 1150001,

        /// <summary>
        /// System.Int32
        /// </summary>
        SpecificDriverClassSpecMajorVersion = 1050515,

        /// <summary>
        /// System.Int32
        /// </summary>
        SpecificDriverClassSpecMinorVersion = 1050516,

        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverDescription = 1050514,

        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverVendor = 1050513,

        /// <summary>
        /// System.String
        /// </summary>
        LogicalName = 1050305,

        /// <summary>
        /// System.String
        /// </summary>
        IoResourceDescriptor = 1050304,

        /// <summary>
        /// System.String
        /// </summary>
        InstrumentFirmwareRevision = 1050510,

        /// <summary>
        /// System.String
        /// </summary>
        InstrumentManufacturer = 1050511,

        /// <summary>
        /// System.String
        /// </summary>
        InstrumentModel = 1050512,

        /// <summary>
        /// System.String
        /// </summary>
        SerialNumber = 1150054,

        /// <summary>
        /// System.String
        /// </summary>
        GroupCapabilities = 1050401,

        /// <summary>
        /// System.String
        /// </summary>
        SupportedInstrumentModels = 1050327,

        /// <summary>
        /// System.Double
        /// </summary>
        AutoRangeValue = 1250331,

        /// <summary>
        /// System.Int32
        /// </summary>
        Function = 1250001,

        /// <summary>
        /// System.Double
        /// </summary>
        Range = 1250002,

        /// <summary>
        /// System.Double
        /// </summary>
        ResolutionDigits = 1250003,

        /// <summary>
        /// System.Double
        /// </summary>
        ResolutionAbsolute = 1250008,

        /// <summary>
        /// System.Double
        /// </summary>
        AcMaxFreq = 1250007,

        /// <summary>
        /// System.Double
        /// </summary>
        AcMinFreq = 1250006,

        /// <summary>
        /// System.Int32
        /// </summary>
        AdcCalibration = 1150022,

        /// <summary>
        /// System.Int32
        /// </summary>
        AutoZero = 1250332,

        /// <summary>
        /// System.Double
        /// </summary>
        CurrentSource = 1150025,

        /// <summary>
        /// System.Int32
        /// </summary>
        DcNoiseRejection = 1150026,

        /// <summary>
        /// System.Double
        /// </summary>
        FreqVoltageRange = 1250101,

        /// <summary>
        /// System.Double
        /// </summary>
        InputResistance = 1150029,

        /// <summary>
        /// System.Int32
        /// </summary>
        OffsetCompOhms = 1150023,

        /// <summary>
        /// System.Double
        /// </summary>
        PowerlineFreq = 1250333,

        /// <summary>
        /// System.Double
        /// </summary>
        ShuntValue = 1150003,

        /// <summary>
        /// System.Int32
        /// </summary>
        CableCompType = 1150045,

        /// <summary>
        /// System.Double
        /// </summary>
        OpenCableCompConductance = 1150049,

        /// <summary>
        /// System.Double
        /// </summary>
        OpenCableCompSusceptance = 1150048,

        /// <summary>
        /// System.Double
        /// </summary>
        ShortCableCompResistance = 1150047,

        /// <summary>
        /// System.Double
        /// </summary>
        ShortCableCompReactance = 1150046,

        /// <summary>
        /// System.Int32
        /// </summary>
        LcCalculationModel = 1150052,

        /// <summary>
        /// System.Int32
        /// </summary>
        DcBias = 1150053,

        /// <summary>
        /// System.Int32
        /// </summary>
        LcNumberMeasToAverage = 1150055,

        /// <summary>
        /// System.Int32
        /// </summary>
        MeasCompleteDest = 1250305,

        /// <summary>
        /// System.Int32
        /// </summary>
        MeasDestSlope = 1150002,

        /// <summary>
        /// System.Double
        /// </summary>
        TriggerDelay = 1250005,

        /// <summary>
        /// System.Int32
        /// </summary>
        TriggerSlope = 1250334,

        /// <summary>
        /// System.Int32
        /// </summary>
        TriggerSource = 1250004,

        /// <summary>
        /// System.Int32
        /// </summary>
        BufferSize = 1150037,

        /// <summary>
        /// System.Int32
        /// </summary>
        Latency = 1150034,

        /// <summary>
        /// System.Int32
        /// </summary>
        SampleCount = 1250301,

        /// <summary>
        /// System.Int32
        /// </summary>
        SampleDelayMode = 1150031,

        /// <summary>
        /// System.Double
        /// </summary>
        SampleInterval = 1250303,

        /// <summary>
        /// System.Int32
        /// </summary>
        SampleTrigger = 1250302,

        /// <summary>
        /// System.Int32
        /// </summary>
        SampleTriggerSlope = 1150010,

        /// <summary>
        /// System.Int32
        /// </summary>
        TriggerCount = 1250304,

        /// <summary>
        /// System.Double
        /// </summary>
        ApertureTime = 1250321,

        /// <summary>
        /// System.Int32
        /// </summary>
        ApertureTimeUnits = 1250322,

        /// <summary>
        /// System.Int32
        /// </summary>
        NumberOfAverages = 1150032,

        /// <summary>
        /// System.Int32
        /// </summary>
        OperationMode = 1150014,

        /// <summary>
        /// System.Double
        /// </summary>
        SettleTime = 1150028,

        /// <summary>
        /// System.Int32
        /// </summary>
        WaveformCoupling = 1150027,

        /// <summary>
        /// System.Int32
        /// </summary>
        WaveformPoints = 1150019,

        /// <summary>
        /// System.Double
        /// </summary>
        WaveformRate = 1150018,
    }
}
